# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2024r1.models.granta_server_api_data_export_datums_rollup_rollup_datum import (  # noqa: F401
    GrantaServerApiDataExportDatumsRollupRollupDatum,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GrantaServerApiDataExportDatumsRollupNumericRollupDatum(
    GrantaServerApiDataExportDatumsRollupRollupDatum
):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "attribute_guid": "str",
        "attribute_identity": "int",
        "database_key": "str",
        "roll_up_type": "GrantaServerApiSchemaTabularColumnsTabularColumnRollUpType",
        "type": "str",
        "unit": "str",
        "value": "float",
    }

    attribute_map: dict[str, str] = {
        "attribute_guid": "attributeGuid",
        "attribute_identity": "attributeIdentity",
        "database_key": "databaseKey",
        "roll_up_type": "rollUpType",
        "type": "type",
        "unit": "unit",
        "value": "value",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        attribute_guid: "Union[str, None, Unset_Type]" = Unset,
        attribute_identity: "Union[int, None, Unset_Type]" = Unset,
        database_key: "Union[str, None, Unset_Type]" = Unset,
        roll_up_type: "Union[GrantaServerApiSchemaTabularColumnsTabularColumnRollUpType, Unset_Type]" = Unset,
        type: "str" = "statisticalRollup",
        unit: "Union[str, None, Unset_Type]" = Unset,
        value: "Union[float, Unset_Type]" = Unset,
    ) -> None:
        """GrantaServerApiDataExportDatumsRollupNumericRollupDatum - a model defined in Swagger

        Parameters
        ----------
        attribute_guid: str, optional
        attribute_identity: int, optional
        database_key: str, optional
        roll_up_type: GrantaServerApiSchemaTabularColumnsTabularColumnRollUpType, optional
        type: str
        unit: str, optional
        value: float, optional
        """
        super().__init__(
            attribute_guid=attribute_guid,
            attribute_identity=attribute_identity,
            database_key=database_key,
            roll_up_type=roll_up_type,
        )
        self._value: Union[float, Unset_Type] = Unset
        self._unit: Union[str, None, Unset_Type] = Unset
        self._type: str

        if value is not Unset:
            self.value = value
        if unit is not Unset:
            self.unit = unit
        self.type = type

    @property
    def value(self) -> "Union[float, Unset_Type]":
        """Gets the value of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.

        Returns
        -------
        Union[float, Unset_Type]
            The value of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.
        """
        return self._value

    @value.setter
    def value(self, value: "Union[float, Unset_Type]") -> None:
        """Sets the value of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.

        Parameters
        ----------
        value: Union[float, Unset_Type]
            The value of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.
        """
        # Field is not nullable
        if value is None:
            raise ValueError("Invalid value for 'value', must not be 'None'")
        self._value = value

    @property
    def unit(self) -> "Union[str, None, Unset_Type]":
        """Gets the unit of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.

        Returns
        -------
        Union[str, None, Unset_Type]
            The unit of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.
        """
        return self._unit

    @unit.setter
    def unit(self, unit: "Union[str, None, Unset_Type]") -> None:
        """Sets the unit of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.

        Parameters
        ----------
        unit: Union[str, None, Unset_Type]
            The unit of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.
        """
        self._unit = unit

    @property
    def type(self) -> "str":
        """Gets the type of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.

        Returns
        -------
        str
            The type of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.
        """
        return self._type

    @type.setter
    def type(self, type: "str") -> None:
        """Sets the type of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.

        Parameters
        ----------
        type: str
            The type of this GrantaServerApiDataExportDatumsRollupNumericRollupDatum.
        """
        # Field is not nullable
        if type is None:
            raise ValueError("Invalid value for 'type', must not be 'None'")
        # Field is required
        if type is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'type', must not be 'Unset'")
        self._type = type

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GrantaServerApiDataExportDatumsRollupNumericRollupDatum):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
