# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2024r1.models.granta_server_api_data_export_export_failures_export_failure import (  # noqa: F401
    GrantaServerApiDataExportExportFailuresExportFailure,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GrantaServerApiDataExportExportFailuresAttributeExportFailure(
    GrantaServerApiDataExportExportFailuresExportFailure
):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "failed_attributes": "list[GrantaServerApiDataExportExportFailuresAttributeReference]",
        "failure_details": "str",
        "failure_reason": "str",
        "type": "str",
    }

    attribute_map: dict[str, str] = {
        "failed_attributes": "failedAttributes",
        "failure_details": "failureDetails",
        "failure_reason": "failureReason",
        "type": "type",
    }

    subtype_mapping: dict[str, str] = {
        "failedAttributes": "GrantaServerApiDataExportExportFailuresAttributeReference",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        failed_attributes: "list[GrantaServerApiDataExportExportFailuresAttributeReference]",
        failure_details: "str",
        failure_reason: "str",
        type: "str" = "attribute",
    ) -> None:
        """GrantaServerApiDataExportExportFailuresAttributeExportFailure - a model defined in Swagger

        Parameters
        ----------
        failed_attributes: list[GrantaServerApiDataExportExportFailuresAttributeReference]
        failure_details: str
        failure_reason: str
        type: str
        """
        super().__init__(failure_details=failure_details, failure_reason=failure_reason)
        self._failed_attributes: list[GrantaServerApiDataExportExportFailuresAttributeReference]
        self._type: str

        self.failed_attributes = failed_attributes
        self.type = type

    @property
    def failed_attributes(
        self,
    ) -> "list[GrantaServerApiDataExportExportFailuresAttributeReference]":
        """Gets the failed_attributes of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.

        Returns
        -------
        list[GrantaServerApiDataExportExportFailuresAttributeReference]
            The failed_attributes of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.
        """
        return self._failed_attributes

    @failed_attributes.setter
    def failed_attributes(
        self, failed_attributes: "list[GrantaServerApiDataExportExportFailuresAttributeReference]"
    ) -> None:
        """Sets the failed_attributes of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.

        Parameters
        ----------
        failed_attributes: list[GrantaServerApiDataExportExportFailuresAttributeReference]
            The failed_attributes of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.
        """
        # Field is not nullable
        if failed_attributes is None:
            raise ValueError("Invalid value for 'failed_attributes', must not be 'None'")
        # Field is required
        if failed_attributes is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'failed_attributes', must not be 'Unset'")
        self._failed_attributes = failed_attributes

    @property
    def type(self) -> "str":
        """Gets the type of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.

        Returns
        -------
        str
            The type of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.
        """
        return self._type

    @type.setter
    def type(self, type: "str") -> None:
        """Sets the type of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.

        Parameters
        ----------
        type: str
            The type of this GrantaServerApiDataExportExportFailuresAttributeExportFailure.
        """
        # Field is not nullable
        if type is None:
            raise ValueError("Invalid value for 'type', must not be 'None'")
        # Field is required
        if type is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'type', must not be 'Unset'")
        self._type = type

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GrantaServerApiDataExportExportFailuresAttributeExportFailure):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
