# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GrantaServerApiSchemaParametersParameter(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator_class_map: dict[str, str]
        They key is discriminator value and the value is associated subtype.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "default_parameter_value_guid": "str",
        "display_names": "dict(str, str)",
        "guid": "str",
        "name": "str",
        "help_path": "str",
    }

    attribute_map: dict[str, str] = {
        "default_parameter_value_guid": "defaultParameterValueGuid",
        "display_names": "displayNames",
        "guid": "guid",
        "name": "name",
        "help_path": "helpPath",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator_value_class_map = {
        "discrete".lower(): "#/components/schemas/GrantaServerApiSchemaParametersDiscreteParameter",
        "numeric".lower(): "#/components/schemas/GrantaServerApiSchemaParametersNumericParameter",
    }

    discriminator: Optional[str] = "type"

    def __init__(
        self,
        *,
        default_parameter_value_guid: "str",
        display_names: "dict[str, str]",
        guid: "str",
        name: "str",
        help_path: "Union[str, None, Unset_Type]" = Unset,
    ) -> None:
        """GrantaServerApiSchemaParametersParameter - a model defined in Swagger

        Parameters
        ----------
        default_parameter_value_guid: str
        display_names: dict[str, str]
        guid: str
        name: str
        help_path: str, optional
        """
        self._help_path: Union[str, None, Unset_Type] = Unset
        self._default_parameter_value_guid: str
        self._display_names: dict[str, str]
        self._name: str
        self._guid: str

        if help_path is not Unset:
            self.help_path = help_path
        self.default_parameter_value_guid = default_parameter_value_guid
        self.display_names = display_names
        self.name = name
        self.guid = guid

    @property
    def help_path(self) -> "Union[str, None, Unset_Type]":
        """Gets the help_path of this GrantaServerApiSchemaParametersParameter.

        Returns
        -------
        Union[str, None, Unset_Type]
            The help_path of this GrantaServerApiSchemaParametersParameter.
        """
        return self._help_path

    @help_path.setter
    def help_path(self, help_path: "Union[str, None, Unset_Type]") -> None:
        """Sets the help_path of this GrantaServerApiSchemaParametersParameter.

        Parameters
        ----------
        help_path: Union[str, None, Unset_Type]
            The help_path of this GrantaServerApiSchemaParametersParameter.
        """
        self._help_path = help_path

    @property
    def default_parameter_value_guid(self) -> "str":
        """Gets the default_parameter_value_guid of this GrantaServerApiSchemaParametersParameter.

        Returns
        -------
        str
            The default_parameter_value_guid of this GrantaServerApiSchemaParametersParameter.
        """
        return self._default_parameter_value_guid

    @default_parameter_value_guid.setter
    def default_parameter_value_guid(self, default_parameter_value_guid: "str") -> None:
        """Sets the default_parameter_value_guid of this GrantaServerApiSchemaParametersParameter.

        Parameters
        ----------
        default_parameter_value_guid: str
            The default_parameter_value_guid of this GrantaServerApiSchemaParametersParameter.
        """
        # Field is not nullable
        if default_parameter_value_guid is None:
            raise ValueError("Invalid value for 'default_parameter_value_guid', must not be 'None'")
        # Field is required
        if default_parameter_value_guid is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError(
                "Invalid value for 'default_parameter_value_guid', must not be 'Unset'"
            )
        self._default_parameter_value_guid = default_parameter_value_guid

    @property
    def display_names(self) -> "dict[str, str]":
        """Gets the display_names of this GrantaServerApiSchemaParametersParameter.

        Returns
        -------
        dict[str, str]
            The display_names of this GrantaServerApiSchemaParametersParameter.
        """
        return self._display_names

    @display_names.setter
    def display_names(self, display_names: "dict[str, str]") -> None:
        """Sets the display_names of this GrantaServerApiSchemaParametersParameter.

        Parameters
        ----------
        display_names: dict[str, str]
            The display_names of this GrantaServerApiSchemaParametersParameter.
        """
        # Field is not nullable
        if display_names is None:
            raise ValueError("Invalid value for 'display_names', must not be 'None'")
        # Field is required
        if display_names is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'display_names', must not be 'Unset'")
        self._display_names = display_names

    @property
    def name(self) -> "str":
        """Gets the name of this GrantaServerApiSchemaParametersParameter.

        Returns
        -------
        str
            The name of this GrantaServerApiSchemaParametersParameter.
        """
        return self._name

    @name.setter
    def name(self, name: "str") -> None:
        """Sets the name of this GrantaServerApiSchemaParametersParameter.

        Parameters
        ----------
        name: str
            The name of this GrantaServerApiSchemaParametersParameter.
        """
        # Field is not nullable
        if name is None:
            raise ValueError("Invalid value for 'name', must not be 'None'")
        # Field is required
        if name is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'name', must not be 'Unset'")
        self._name = name

    @property
    def guid(self) -> "str":
        """Gets the guid of this GrantaServerApiSchemaParametersParameter.

        Returns
        -------
        str
            The guid of this GrantaServerApiSchemaParametersParameter.
        """
        return self._guid

    @guid.setter
    def guid(self, guid: "str") -> None:
        """Sets the guid of this GrantaServerApiSchemaParametersParameter.

        Parameters
        ----------
        guid: str
            The guid of this GrantaServerApiSchemaParametersParameter.
        """
        # Field is not nullable
        if guid is None:
            raise ValueError("Invalid value for 'guid', must not be 'None'")
        # Field is required
        if guid is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'guid', must not be 'Unset'")
        self._guid = guid

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Returns the real base class as determined by the discriminator

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class
        """
        discriminator_value = str(data[cls._get_discriminator_field_name()]).lower()
        # The actual class name is not available in swagger-codegen,
        # so we have to extract it from the JSON reference
        return cls.discriminator_value_class_map[discriminator_value].rsplit("/", 1)[-1]

    @classmethod
    def _get_discriminator_field_name(cls) -> str:
        assert cls.discriminator
        name_tokens = cls.discriminator.split("_")
        later_tokens = [element.capitalize() for element in name_tokens[1:]]
        return "".join([name_tokens[0], *later_tokens])

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GrantaServerApiSchemaParametersParameter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
