# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "count": "int",
        "default_x_axis_parameter_guid_values": "list[GrantaServerApiAggregationsValueWithCountOfSystemGuid]",
        "default_x_axis_parameter_identity_values": "list[GrantaServerApiAggregationsValueWithCountOfSystemInt32]",
        "maximum_number_of_points": "int",
        "minimum_number_of_points": "int",
        "show_as_table_values": "list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean]",
    }

    attribute_map: dict[str, str] = {
        "count": "count",
        "default_x_axis_parameter_guid_values": "defaultXAxisParameterGuidValues",
        "default_x_axis_parameter_identity_values": "defaultXAxisParameterIdentityValues",
        "maximum_number_of_points": "maximumNumberOfPoints",
        "minimum_number_of_points": "minimumNumberOfPoints",
        "show_as_table_values": "showAsTableValues",
    }

    subtype_mapping: dict[str, str] = {
        "defaultXAxisParameterIdentityValues": "GrantaServerApiAggregationsValueWithCountOfSystemInt32",
        "defaultXAxisParameterGuidValues": "GrantaServerApiAggregationsValueWithCountOfSystemGuid",
        "showAsTableValues": "GrantaServerApiAggregationsValueWithCountOfSystemBoolean",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        count: "Union[int, Unset_Type]" = Unset,
        default_x_axis_parameter_guid_values: "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], None, Unset_Type]" = Unset,
        default_x_axis_parameter_identity_values: "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], None, Unset_Type]" = Unset,
        maximum_number_of_points: "Union[int, None, Unset_Type]" = Unset,
        minimum_number_of_points: "Union[int, None, Unset_Type]" = Unset,
        show_as_table_values: "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], None, Unset_Type]" = Unset,
    ) -> None:
        """GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation - a model defined in Swagger

        Parameters
        ----------
        count: int, optional
        default_x_axis_parameter_guid_values: list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], optional
        default_x_axis_parameter_identity_values: list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], optional
        maximum_number_of_points: int, optional
        minimum_number_of_points: int, optional
        show_as_table_values: list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], optional
        """
        self._default_x_axis_parameter_identity_values: Union[
            list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], None, Unset_Type
        ] = Unset
        self._default_x_axis_parameter_guid_values: Union[
            list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], None, Unset_Type
        ] = Unset
        self._show_as_table_values: Union[
            list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], None, Unset_Type
        ] = Unset
        self._minimum_number_of_points: Union[int, None, Unset_Type] = Unset
        self._maximum_number_of_points: Union[int, None, Unset_Type] = Unset
        self._count: Union[int, Unset_Type] = Unset

        if default_x_axis_parameter_identity_values is not Unset:
            self.default_x_axis_parameter_identity_values = default_x_axis_parameter_identity_values
        if default_x_axis_parameter_guid_values is not Unset:
            self.default_x_axis_parameter_guid_values = default_x_axis_parameter_guid_values
        if show_as_table_values is not Unset:
            self.show_as_table_values = show_as_table_values
        if minimum_number_of_points is not Unset:
            self.minimum_number_of_points = minimum_number_of_points
        if maximum_number_of_points is not Unset:
            self.maximum_number_of_points = maximum_number_of_points
        if count is not Unset:
            self.count = count

    @property
    def default_x_axis_parameter_identity_values(
        self,
    ) -> "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], None, Unset_Type]":
        """Gets the default_x_axis_parameter_identity_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Returns
        -------
        Union[list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], None, Unset_Type]
            The default_x_axis_parameter_identity_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        return self._default_x_axis_parameter_identity_values

    @default_x_axis_parameter_identity_values.setter
    def default_x_axis_parameter_identity_values(
        self,
        default_x_axis_parameter_identity_values: "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], None, Unset_Type]",
    ) -> None:
        """Sets the default_x_axis_parameter_identity_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Parameters
        ----------
        default_x_axis_parameter_identity_values: Union[list[GrantaServerApiAggregationsValueWithCountOfSystemInt32], None, Unset_Type]
            The default_x_axis_parameter_identity_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        self._default_x_axis_parameter_identity_values = default_x_axis_parameter_identity_values

    @property
    def default_x_axis_parameter_guid_values(
        self,
    ) -> "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], None, Unset_Type]":
        """Gets the default_x_axis_parameter_guid_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Returns
        -------
        Union[list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], None, Unset_Type]
            The default_x_axis_parameter_guid_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        return self._default_x_axis_parameter_guid_values

    @default_x_axis_parameter_guid_values.setter
    def default_x_axis_parameter_guid_values(
        self,
        default_x_axis_parameter_guid_values: "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], None, Unset_Type]",
    ) -> None:
        """Sets the default_x_axis_parameter_guid_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Parameters
        ----------
        default_x_axis_parameter_guid_values: Union[list[GrantaServerApiAggregationsValueWithCountOfSystemGuid], None, Unset_Type]
            The default_x_axis_parameter_guid_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        self._default_x_axis_parameter_guid_values = default_x_axis_parameter_guid_values

    @property
    def show_as_table_values(
        self,
    ) -> "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], None, Unset_Type]":
        """Gets the show_as_table_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Returns
        -------
        Union[list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], None, Unset_Type]
            The show_as_table_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        return self._show_as_table_values

    @show_as_table_values.setter
    def show_as_table_values(
        self,
        show_as_table_values: "Union[list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], None, Unset_Type]",
    ) -> None:
        """Sets the show_as_table_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Parameters
        ----------
        show_as_table_values: Union[list[GrantaServerApiAggregationsValueWithCountOfSystemBoolean], None, Unset_Type]
            The show_as_table_values of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        self._show_as_table_values = show_as_table_values

    @property
    def minimum_number_of_points(self) -> "Union[int, None, Unset_Type]":
        """Gets the minimum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Returns
        -------
        Union[int, None, Unset_Type]
            The minimum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        return self._minimum_number_of_points

    @minimum_number_of_points.setter
    def minimum_number_of_points(
        self, minimum_number_of_points: "Union[int, None, Unset_Type]"
    ) -> None:
        """Sets the minimum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Parameters
        ----------
        minimum_number_of_points: Union[int, None, Unset_Type]
            The minimum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        self._minimum_number_of_points = minimum_number_of_points

    @property
    def maximum_number_of_points(self) -> "Union[int, None, Unset_Type]":
        """Gets the maximum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Returns
        -------
        Union[int, None, Unset_Type]
            The maximum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        return self._maximum_number_of_points

    @maximum_number_of_points.setter
    def maximum_number_of_points(
        self, maximum_number_of_points: "Union[int, None, Unset_Type]"
    ) -> None:
        """Sets the maximum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.

        Parameters
        ----------
        maximum_number_of_points: Union[int, None, Unset_Type]
            The maximum_number_of_points of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        self._maximum_number_of_points = maximum_number_of_points

    @property
    def count(self) -> "Union[int, Unset_Type]":
        """Gets the count of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        The number of record where the data is a series graph

        Returns
        -------
        Union[int, Unset_Type]
            The count of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        return self._count

    @count.setter
    def count(self, count: "Union[int, Unset_Type]") -> None:
        """Sets the count of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        The number of record where the data is a series graph

        Parameters
        ----------
        count: Union[int, Unset_Type]
            The count of this GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation.
        """
        # Field is not nullable
        if count is None:
            raise ValueError("Invalid value for 'count', must not be 'None'")
        self._count = count

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GrantaServerApiAggregationsFloatFunctionalGridGraphAggregation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
