# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r1.models.gsa_graph import GsaGraph  # noqa: F401
from ansys.grantami.serverapi_openapi.v2025r1.models.gsa_graph_type import GsaGraphType

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaGridGraph(GsaGraph):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator_class_map: dict[str, str]
        They key is discriminator value and the value is associated subtype.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "all_parameters": "list[GsaSlimParameter]",
        "default_x_axis_parameter": "GsaSlimParameter",
        "functional_type": "GsaFunctionalType",
        "graph_type": "GsaGraphType",
    }

    attribute_map: dict[str, str] = {
        "all_parameters": "allParameters",
        "default_x_axis_parameter": "defaultXAxisParameter",
        "functional_type": "functionalType",
        "graph_type": "graphType",
    }

    subtype_mapping: dict[str, str] = {
        "functionalType": "GsaFunctionalType",
        "defaultXAxisParameter": "GsaSlimParameter",
        "allParameters": "GsaSlimParameter",
    }

    discriminator_value_class_map = {
        "float".lower(): "#/components/schemas/GsaFloatGridGraph",
        "discrete".lower(): "#/components/schemas/GsaDiscreteGridGraph",
    }

    discriminator: Optional[str] = "functional_type"

    def __init__(
        self,
        *,
        all_parameters: "list[GsaSlimParameter]",
        default_x_axis_parameter: "GsaSlimParameter",
        functional_type: "GsaFunctionalType",
        graph_type: "GsaGraphType" = GsaGraphType.GRID,
    ) -> None:
        """GsaGridGraph - a model defined in Swagger

        Parameters
        ----------
        all_parameters: list[GsaSlimParameter]
        default_x_axis_parameter: GsaSlimParameter
        functional_type: GsaFunctionalType
        graph_type: GsaGraphType
        """
        super().__init__(graph_type=graph_type)
        self._functional_type: GsaFunctionalType
        self._default_x_axis_parameter: GsaSlimParameter
        self._all_parameters: list[GsaSlimParameter]

        self.functional_type = functional_type
        self.default_x_axis_parameter = default_x_axis_parameter
        self.all_parameters = all_parameters

    @property
    def functional_type(self) -> "GsaFunctionalType":
        """Gets the functional_type of this GsaGridGraph.

        Returns
        -------
        GsaFunctionalType
            The functional_type of this GsaGridGraph.
        """
        return self._functional_type

    @functional_type.setter
    def functional_type(self, functional_type: "GsaFunctionalType") -> None:
        """Sets the functional_type of this GsaGridGraph.

        Parameters
        ----------
        functional_type: GsaFunctionalType
            The functional_type of this GsaGridGraph.
        """
        # Field is not nullable
        if functional_type is None:
            raise ValueError("Invalid value for 'functional_type', must not be 'None'")
        # Field is required
        if functional_type is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'functional_type', must not be 'Unset'")
        self._functional_type = functional_type

    @property
    def default_x_axis_parameter(self) -> "GsaSlimParameter":
        """Gets the default_x_axis_parameter of this GsaGridGraph.

        Returns
        -------
        GsaSlimParameter
            The default_x_axis_parameter of this GsaGridGraph.
        """
        return self._default_x_axis_parameter

    @default_x_axis_parameter.setter
    def default_x_axis_parameter(self, default_x_axis_parameter: "GsaSlimParameter") -> None:
        """Sets the default_x_axis_parameter of this GsaGridGraph.

        Parameters
        ----------
        default_x_axis_parameter: GsaSlimParameter
            The default_x_axis_parameter of this GsaGridGraph.
        """
        # Field is not nullable
        if default_x_axis_parameter is None:
            raise ValueError("Invalid value for 'default_x_axis_parameter', must not be 'None'")
        # Field is required
        if default_x_axis_parameter is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'default_x_axis_parameter', must not be 'Unset'")
        self._default_x_axis_parameter = default_x_axis_parameter

    @property
    def all_parameters(self) -> "list[GsaSlimParameter]":
        """Gets the all_parameters of this GsaGridGraph.

        Returns
        -------
        list[GsaSlimParameter]
            The all_parameters of this GsaGridGraph.
        """
        return self._all_parameters

    @all_parameters.setter
    def all_parameters(self, all_parameters: "list[GsaSlimParameter]") -> None:
        """Sets the all_parameters of this GsaGridGraph.

        Parameters
        ----------
        all_parameters: list[GsaSlimParameter]
            The all_parameters of this GsaGridGraph.
        """
        # Field is not nullable
        if all_parameters is None:
            raise ValueError("Invalid value for 'all_parameters', must not be 'None'")
        # Field is required
        if all_parameters is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'all_parameters', must not be 'Unset'")
        self._all_parameters = all_parameters

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Returns the real base class as determined by the discriminator

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class
        """
        discriminator_value = str(data[cls._get_discriminator_field_name()]).lower()
        # The actual class name is not available in swagger-codegen,
        # so we have to extract it from the JSON reference
        return cls.discriminator_value_class_map[discriminator_value].rsplit("/", 1)[-1]

    @classmethod
    def _get_discriminator_field_name(cls) -> str:
        assert cls.discriminator
        name_tokens = cls.discriminator.split("_")
        later_tokens = [element.capitalize() for element in name_tokens[1:]]
        return "".join([name_tokens[0], *later_tokens])

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaGridGraph):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
