# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r1.models.gsa_criterion import GsaCriterion  # noqa: F401
from ansys.grantami.serverapi_openapi.v2025r1.models.gsa_criterion_type import GsaCriterionType

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaRecordAncestorCriterion(GsaCriterion):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "type": "GsaCriterionType",
        "ancestor_identity": "int",
        "direct_parent_only": "bool",
    }

    attribute_map: dict[str, str] = {
        "type": "type",
        "ancestor_identity": "ancestorIdentity",
        "direct_parent_only": "directParentOnly",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        type: "GsaCriterionType" = GsaCriterionType.RECORDANCESTOR,
        ancestor_identity: "Union[int, None, Unset_Type]" = Unset,
        direct_parent_only: "Union[bool, None, Unset_Type]" = Unset,
    ) -> None:
        """GsaRecordAncestorCriterion - a model defined in Swagger

        Parameters
        ----------
        type: GsaCriterionType
        ancestor_identity: int, optional
        direct_parent_only: bool, optional
        """
        super().__init__(type=type)
        self._ancestor_identity: Union[int, None, Unset_Type] = Unset
        self._direct_parent_only: Union[bool, None, Unset_Type] = Unset

        if ancestor_identity is not Unset:
            self.ancestor_identity = ancestor_identity
        if direct_parent_only is not Unset:
            self.direct_parent_only = direct_parent_only

    @property
    def ancestor_identity(self) -> "Union[int, None, Unset_Type]":
        """Gets the ancestor_identity of this GsaRecordAncestorCriterion.

        Returns
        -------
        Union[int, None, Unset_Type]
            The ancestor_identity of this GsaRecordAncestorCriterion.
        """
        return self._ancestor_identity

    @ancestor_identity.setter
    def ancestor_identity(self, ancestor_identity: "Union[int, None, Unset_Type]") -> None:
        """Sets the ancestor_identity of this GsaRecordAncestorCriterion.

        Parameters
        ----------
        ancestor_identity: Union[int, None, Unset_Type]
            The ancestor_identity of this GsaRecordAncestorCriterion.
        """
        self._ancestor_identity = ancestor_identity

    @property
    def direct_parent_only(self) -> "Union[bool, None, Unset_Type]":
        """Gets the direct_parent_only of this GsaRecordAncestorCriterion.

        Returns
        -------
        Union[bool, None, Unset_Type]
            The direct_parent_only of this GsaRecordAncestorCriterion.
        """
        return self._direct_parent_only

    @direct_parent_only.setter
    def direct_parent_only(self, direct_parent_only: "Union[bool, None, Unset_Type]") -> None:
        """Sets the direct_parent_only of this GsaRecordAncestorCriterion.

        Parameters
        ----------
        direct_parent_only: Union[bool, None, Unset_Type]
            The direct_parent_only of this GsaRecordAncestorCriterion.
        """
        self._direct_parent_only = direct_parent_only

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaRecordAncestorCriterion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
