# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r1.models.gsa_parameter_type import GsaParameterType
from ansys.grantami.serverapi_openapi.v2025r1.models.gsa_update_parameter import (  # noqa: F401
    GsaUpdateParameter,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaUpdateNumericParameter(GsaUpdateParameter):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "type": "GsaParameterType",
        "default_parameter_value_guid": "str",
        "guid": "str",
        "help_path": "str",
        "interpolation_type": "GsaParameterInterpolationType",
        "name": "str",
        "scale_type": "GsaParameterScaleType",
        "unit": "GsaSlimEntity",
    }

    attribute_map: dict[str, str] = {
        "type": "type",
        "default_parameter_value_guid": "defaultParameterValueGuid",
        "guid": "guid",
        "help_path": "helpPath",
        "interpolation_type": "interpolationType",
        "name": "name",
        "scale_type": "scaleType",
        "unit": "unit",
    }

    subtype_mapping: dict[str, str] = {
        "unit": "GsaSlimEntity",
        "interpolationType": "GsaParameterInterpolationType",
        "scaleType": "GsaParameterScaleType",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        type: "GsaParameterType" = GsaParameterType.NUMERIC,
        default_parameter_value_guid: "Union[str, Unset_Type]" = Unset,
        guid: "Union[str, Unset_Type]" = Unset,
        help_path: "Union[str, None, Unset_Type]" = Unset,
        interpolation_type: "Union[GsaParameterInterpolationType, Unset_Type]" = Unset,
        name: "Union[str, Unset_Type]" = Unset,
        scale_type: "Union[GsaParameterScaleType, Unset_Type]" = Unset,
        unit: "Union[GsaSlimEntity, Unset_Type]" = Unset,
    ) -> None:
        """GsaUpdateNumericParameter - a model defined in Swagger

        Parameters
        ----------
        type: GsaParameterType
        default_parameter_value_guid: str, optional
        guid: str, optional
        help_path: str, optional
        interpolation_type: GsaParameterInterpolationType, optional
        name: str, optional
        scale_type: GsaParameterScaleType, optional
        unit: GsaSlimEntity, optional
        """
        super().__init__(
            type=type,
            default_parameter_value_guid=default_parameter_value_guid,
            guid=guid,
            help_path=help_path,
            name=name,
        )
        self._unit: Union[GsaSlimEntity, Unset_Type] = Unset
        self._interpolation_type: Union[GsaParameterInterpolationType, Unset_Type] = Unset
        self._scale_type: Union[GsaParameterScaleType, Unset_Type] = Unset

        if unit is not Unset:
            self.unit = unit
        if interpolation_type is not Unset:
            self.interpolation_type = interpolation_type
        if scale_type is not Unset:
            self.scale_type = scale_type

    @property
    def unit(self) -> "Union[GsaSlimEntity, Unset_Type]":
        """Gets the unit of this GsaUpdateNumericParameter.

        Returns
        -------
        Union[GsaSlimEntity, Unset_Type]
            The unit of this GsaUpdateNumericParameter.
        """
        return self._unit

    @unit.setter
    def unit(self, unit: "Union[GsaSlimEntity, Unset_Type]") -> None:
        """Sets the unit of this GsaUpdateNumericParameter.

        Parameters
        ----------
        unit: Union[GsaSlimEntity, Unset_Type]
            The unit of this GsaUpdateNumericParameter.
        """
        # Field is not nullable
        if unit is None:
            raise ValueError("Invalid value for 'unit', must not be 'None'")
        self._unit = unit

    @property
    def interpolation_type(self) -> "Union[GsaParameterInterpolationType, Unset_Type]":
        """Gets the interpolation_type of this GsaUpdateNumericParameter.

        Returns
        -------
        Union[GsaParameterInterpolationType, Unset_Type]
            The interpolation_type of this GsaUpdateNumericParameter.
        """
        return self._interpolation_type

    @interpolation_type.setter
    def interpolation_type(
        self, interpolation_type: "Union[GsaParameterInterpolationType, Unset_Type]"
    ) -> None:
        """Sets the interpolation_type of this GsaUpdateNumericParameter.

        Parameters
        ----------
        interpolation_type: Union[GsaParameterInterpolationType, Unset_Type]
            The interpolation_type of this GsaUpdateNumericParameter.
        """
        # Field is not nullable
        if interpolation_type is None:
            raise ValueError("Invalid value for 'interpolation_type', must not be 'None'")
        self._interpolation_type = interpolation_type

    @property
    def scale_type(self) -> "Union[GsaParameterScaleType, Unset_Type]":
        """Gets the scale_type of this GsaUpdateNumericParameter.

        Returns
        -------
        Union[GsaParameterScaleType, Unset_Type]
            The scale_type of this GsaUpdateNumericParameter.
        """
        return self._scale_type

    @scale_type.setter
    def scale_type(self, scale_type: "Union[GsaParameterScaleType, Unset_Type]") -> None:
        """Sets the scale_type of this GsaUpdateNumericParameter.

        Parameters
        ----------
        scale_type: Union[GsaParameterScaleType, Unset_Type]
            The scale_type of this GsaUpdateNumericParameter.
        """
        # Field is not nullable
        if scale_type is None:
            raise ValueError("Invalid value for 'scale_type', must not be 'None'")
        self._scale_type = scale_type

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaUpdateNumericParameter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
