# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaBulkResponseItem(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "status": "SystemNetHttpStatusCode",
        "body": "object",
        "headers": "dict(str, str)",
    }

    attribute_map: dict[str, str] = {
        "status": "status",
        "body": "body",
        "headers": "headers",
    }

    subtype_mapping: dict[str, str] = {
        "status": "SystemNetHttpStatusCode",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        status: "SystemNetHttpStatusCode",
        body: "Union[object, None, Unset_Type]" = Unset,
        headers: "Union[dict[str, str], None, Unset_Type]" = Unset,
    ) -> None:
        """GsaBulkResponseItem - a model defined in Swagger

        Parameters
        ----------
        status: SystemNetHttpStatusCode
        body: object, optional
        headers: dict[str, str], optional
        """
        self._status: SystemNetHttpStatusCode
        self._body: Union[object, None, Unset_Type] = Unset
        self._headers: Union[dict[str, str], None, Unset_Type] = Unset

        self.status = status
        if body is not Unset:
            self.body = body
        if headers is not Unset:
            self.headers = headers

    @property
    def status(self) -> "SystemNetHttpStatusCode":
        """Gets the status of this GsaBulkResponseItem.

        Returns
        -------
        SystemNetHttpStatusCode
            The status of this GsaBulkResponseItem.
        """
        return self._status

    @status.setter
    def status(self, status: "SystemNetHttpStatusCode") -> None:
        """Sets the status of this GsaBulkResponseItem.

        Parameters
        ----------
        status: SystemNetHttpStatusCode
            The status of this GsaBulkResponseItem.
        """
        # Field is not nullable
        if status is None:
            raise ValueError("Invalid value for 'status', must not be 'None'")
        # Field is required
        if status is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'status', must not be 'Unset'")
        self._status = status

    @property
    def body(self) -> "Union[object, None, Unset_Type]":
        """Gets the body of this GsaBulkResponseItem.
        The response body. The type of this object depends on the request being sent.  It should be the same as if the request were sent separately.

        Returns
        -------
        Union[object, None, Unset_Type]
            The body of this GsaBulkResponseItem.
        """
        return self._body

    @body.setter
    def body(self, body: "Union[object, None, Unset_Type]") -> None:
        """Sets the body of this GsaBulkResponseItem.
        The response body. The type of this object depends on the request being sent.  It should be the same as if the request were sent separately.

        Parameters
        ----------
        body: Union[object, None, Unset_Type]
            The body of this GsaBulkResponseItem.
        """
        self._body = body

    @property
    def headers(self) -> "Union[dict[str, str], None, Unset_Type]":
        """Gets the headers of this GsaBulkResponseItem.

        Returns
        -------
        Union[dict[str, str], None, Unset_Type]
            The headers of this GsaBulkResponseItem.
        """
        return self._headers

    @headers.setter
    def headers(self, headers: "Union[dict[str, str], None, Unset_Type]") -> None:
        """Sets the headers of this GsaBulkResponseItem.

        Parameters
        ----------
        headers: Union[dict[str, str], None, Unset_Type]
            The headers of this GsaBulkResponseItem.
        """
        self._headers = headers

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaBulkResponseItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
