# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaConnectionDetails(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "data_source": "str",
        "initial_catalog": "str",
        "additional_sql_parameters": "str",
        "sql_password": "str",
        "sql_username": "str",
        "use_integrated_security": "bool",
    }

    attribute_map: dict[str, str] = {
        "data_source": "dataSource",
        "initial_catalog": "initialCatalog",
        "additional_sql_parameters": "additionalSqlParameters",
        "sql_password": "sqlPassword",
        "sql_username": "sqlUsername",
        "use_integrated_security": "useIntegratedSecurity",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        data_source: "str",
        initial_catalog: "str",
        additional_sql_parameters: "Union[str, None, Unset_Type]" = Unset,
        sql_password: "Union[str, None, Unset_Type]" = Unset,
        sql_username: "Union[str, None, Unset_Type]" = Unset,
        use_integrated_security: "Union[bool, None, Unset_Type]" = Unset,
    ) -> None:
        """GsaConnectionDetails - a model defined in Swagger

        Parameters
        ----------
        data_source: str
        initial_catalog: str
        additional_sql_parameters: str, optional
        sql_password: str, optional
        sql_username: str, optional
        use_integrated_security: bool, optional
        """
        self._data_source: str
        self._use_integrated_security: Union[bool, None, Unset_Type] = Unset
        self._sql_username: Union[str, None, Unset_Type] = Unset
        self._sql_password: Union[str, None, Unset_Type] = Unset
        self._initial_catalog: str
        self._additional_sql_parameters: Union[str, None, Unset_Type] = Unset

        self.data_source = data_source
        if use_integrated_security is not Unset:
            self.use_integrated_security = use_integrated_security
        if sql_username is not Unset:
            self.sql_username = sql_username
        if sql_password is not Unset:
            self.sql_password = sql_password
        self.initial_catalog = initial_catalog
        if additional_sql_parameters is not Unset:
            self.additional_sql_parameters = additional_sql_parameters

    @property
    def data_source(self) -> "str":
        """Gets the data_source of this GsaConnectionDetails.
        The SQL server data source

        Returns
        -------
        str
            The data_source of this GsaConnectionDetails.
        """
        return self._data_source

    @data_source.setter
    def data_source(self, data_source: "str") -> None:
        """Sets the data_source of this GsaConnectionDetails.
        The SQL server data source

        Parameters
        ----------
        data_source: str
            The data_source of this GsaConnectionDetails.
        """
        # Field is not nullable
        if data_source is None:
            raise ValueError("Invalid value for 'data_source', must not be 'None'")
        # Field is required
        if data_source is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'data_source', must not be 'Unset'")
        self._data_source = data_source

    @property
    def use_integrated_security(self) -> "Union[bool, None, Unset_Type]":
        """Gets the use_integrated_security of this GsaConnectionDetails.
        Set to true if the SQL connection to the new database should use Windows authentication

        Returns
        -------
        Union[bool, None, Unset_Type]
            The use_integrated_security of this GsaConnectionDetails.
        """
        return self._use_integrated_security

    @use_integrated_security.setter
    def use_integrated_security(
        self, use_integrated_security: "Union[bool, None, Unset_Type]"
    ) -> None:
        """Sets the use_integrated_security of this GsaConnectionDetails.
        Set to true if the SQL connection to the new database should use Windows authentication

        Parameters
        ----------
        use_integrated_security: Union[bool, None, Unset_Type]
            The use_integrated_security of this GsaConnectionDetails.
        """
        self._use_integrated_security = use_integrated_security

    @property
    def sql_username(self) -> "Union[str, None, Unset_Type]":
        """Gets the sql_username of this GsaConnectionDetails.
        The username to use if the new database should use SQL authentication. The password must also be provided.

        Returns
        -------
        Union[str, None, Unset_Type]
            The sql_username of this GsaConnectionDetails.
        """
        return self._sql_username

    @sql_username.setter
    def sql_username(self, sql_username: "Union[str, None, Unset_Type]") -> None:
        """Sets the sql_username of this GsaConnectionDetails.
        The username to use if the new database should use SQL authentication. The password must also be provided.

        Parameters
        ----------
        sql_username: Union[str, None, Unset_Type]
            The sql_username of this GsaConnectionDetails.
        """
        self._sql_username = sql_username

    @property
    def sql_password(self) -> "Union[str, None, Unset_Type]":
        """Gets the sql_password of this GsaConnectionDetails.
        The password to use if the new database should use SQL authentication. The username must also be provided.

        Returns
        -------
        Union[str, None, Unset_Type]
            The sql_password of this GsaConnectionDetails.
        """
        return self._sql_password

    @sql_password.setter
    def sql_password(self, sql_password: "Union[str, None, Unset_Type]") -> None:
        """Sets the sql_password of this GsaConnectionDetails.
        The password to use if the new database should use SQL authentication. The username must also be provided.

        Parameters
        ----------
        sql_password: Union[str, None, Unset_Type]
            The sql_password of this GsaConnectionDetails.
        """
        self._sql_password = sql_password

    @property
    def initial_catalog(self) -> "str":
        """Gets the initial_catalog of this GsaConnectionDetails.
        The name of the database in SQL server

        Returns
        -------
        str
            The initial_catalog of this GsaConnectionDetails.
        """
        return self._initial_catalog

    @initial_catalog.setter
    def initial_catalog(self, initial_catalog: "str") -> None:
        """Sets the initial_catalog of this GsaConnectionDetails.
        The name of the database in SQL server

        Parameters
        ----------
        initial_catalog: str
            The initial_catalog of this GsaConnectionDetails.
        """
        # Field is not nullable
        if initial_catalog is None:
            raise ValueError("Invalid value for 'initial_catalog', must not be 'None'")
        # Field is required
        if initial_catalog is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'initial_catalog', must not be 'Unset'")
        self._initial_catalog = initial_catalog

    @property
    def additional_sql_parameters(self) -> "Union[str, None, Unset_Type]":
        """Gets the additional_sql_parameters of this GsaConnectionDetails.
        (Optional) Any additional parameters that will be added to the SQL connection string for the database. Must be a valid SQL connection string format.

        Returns
        -------
        Union[str, None, Unset_Type]
            The additional_sql_parameters of this GsaConnectionDetails.
        """
        return self._additional_sql_parameters

    @additional_sql_parameters.setter
    def additional_sql_parameters(
        self, additional_sql_parameters: "Union[str, None, Unset_Type]"
    ) -> None:
        """Sets the additional_sql_parameters of this GsaConnectionDetails.
        (Optional) Any additional parameters that will be added to the SQL connection string for the database. Must be a valid SQL connection string format.

        Parameters
        ----------
        additional_sql_parameters: Union[str, None, Unset_Type]
            The additional_sql_parameters of this GsaConnectionDetails.
        """
        self._additional_sql_parameters = additional_sql_parameters

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaConnectionDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
