# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_attribute_type import GsaAttributeType
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_data_export_link_datum import (  # noqa: F401
    GsaDataExportLinkDatum,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaDataExportTabularDatum(GsaDataExportLinkDatum):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "attribute_guid": "str",
        "attribute_identity": "int",
        "datum_type": "GsaAttributeType",
        "link_datum_type": "str",
        "not_applicable": "str",
        "attribute_name": "str",
        "meta_datums": "list[GsaDataExportDatum]",
        "summary_row": "list[GsaDataExportRollupDatum]",
        "tabular_rows": "list[GsaDataExportTabularRow]",
    }

    attribute_map: dict[str, str] = {
        "attribute_guid": "attributeGuid",
        "attribute_identity": "attributeIdentity",
        "datum_type": "datumType",
        "link_datum_type": "linkDatumType",
        "not_applicable": "notApplicable",
        "attribute_name": "attributeName",
        "meta_datums": "metaDatums",
        "summary_row": "summaryRow",
        "tabular_rows": "tabularRows",
    }

    subtype_mapping: dict[str, str] = {
        "tabularRows": "GsaDataExportTabularRow",
        "summaryRow": "GsaDataExportRollupDatum",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        attribute_guid: "str",
        attribute_identity: "int",
        datum_type: "GsaAttributeType" = GsaAttributeType.LINK,
        link_datum_type: "str" = "tabular",
        not_applicable: "str" = "applicable",
        attribute_name: "Union[str, None, Unset_Type]" = Unset,
        meta_datums: "Union[list[GsaDataExportDatum], None, Unset_Type]" = Unset,
        summary_row: "Union[list[GsaDataExportRollupDatum], None, Unset_Type]" = Unset,
        tabular_rows: "Union[list[GsaDataExportTabularRow], None, Unset_Type]" = Unset,
    ) -> None:
        """GsaDataExportTabularDatum - a model defined in Swagger

        Parameters
        ----------
        attribute_guid: str
        attribute_identity: int
        datum_type: GsaAttributeType
        link_datum_type: str
        not_applicable: str
        attribute_name: str, optional
        meta_datums: list[GsaDataExportDatum], optional
        summary_row: list[GsaDataExportRollupDatum], optional
        tabular_rows: list[GsaDataExportTabularRow], optional
        """
        super().__init__(
            attribute_guid=attribute_guid,
            attribute_identity=attribute_identity,
            datum_type=datum_type,
            link_datum_type=link_datum_type,
            not_applicable=not_applicable,
            meta_datums=meta_datums,
        )
        self._attribute_name: Union[str, None, Unset_Type] = Unset
        self._tabular_rows: Union[list[GsaDataExportTabularRow], None, Unset_Type] = Unset
        self._summary_row: Union[list[GsaDataExportRollupDatum], None, Unset_Type] = Unset

        if attribute_name is not Unset:
            self.attribute_name = attribute_name
        if tabular_rows is not Unset:
            self.tabular_rows = tabular_rows
        if summary_row is not Unset:
            self.summary_row = summary_row

    @property
    def attribute_name(self) -> "Union[str, None, Unset_Type]":
        """Gets the attribute_name of this GsaDataExportTabularDatum.

        Returns
        -------
        Union[str, None, Unset_Type]
            The attribute_name of this GsaDataExportTabularDatum.
        """
        return self._attribute_name

    @attribute_name.setter
    def attribute_name(self, attribute_name: "Union[str, None, Unset_Type]") -> None:
        """Sets the attribute_name of this GsaDataExportTabularDatum.

        Parameters
        ----------
        attribute_name: Union[str, None, Unset_Type]
            The attribute_name of this GsaDataExportTabularDatum.
        """
        self._attribute_name = attribute_name

    @property
    def tabular_rows(self) -> "Union[list[GsaDataExportTabularRow], None, Unset_Type]":
        """Gets the tabular_rows of this GsaDataExportTabularDatum.

        Returns
        -------
        Union[list[GsaDataExportTabularRow], None, Unset_Type]
            The tabular_rows of this GsaDataExportTabularDatum.
        """
        return self._tabular_rows

    @tabular_rows.setter
    def tabular_rows(
        self, tabular_rows: "Union[list[GsaDataExportTabularRow], None, Unset_Type]"
    ) -> None:
        """Sets the tabular_rows of this GsaDataExportTabularDatum.

        Parameters
        ----------
        tabular_rows: Union[list[GsaDataExportTabularRow], None, Unset_Type]
            The tabular_rows of this GsaDataExportTabularDatum.
        """
        self._tabular_rows = tabular_rows

    @property
    def summary_row(self) -> "Union[list[GsaDataExportRollupDatum], None, Unset_Type]":
        """Gets the summary_row of this GsaDataExportTabularDatum.

        Returns
        -------
        Union[list[GsaDataExportRollupDatum], None, Unset_Type]
            The summary_row of this GsaDataExportTabularDatum.
        """
        return self._summary_row

    @summary_row.setter
    def summary_row(
        self, summary_row: "Union[list[GsaDataExportRollupDatum], None, Unset_Type]"
    ) -> None:
        """Sets the summary_row of this GsaDataExportTabularDatum.

        Parameters
        ----------
        summary_row: Union[list[GsaDataExportRollupDatum], None, Unset_Type]
            The summary_row of this GsaDataExportTabularDatum.
        """
        self._summary_row = summary_row

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaDataExportTabularDatum):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
