# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaExportFailure(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator_class_map: dict[str, str]
        They key is discriminator value and the value is associated subtype.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "failure_details": "str",
        "failure_reason": "str",
        "type": "GsaExportFailureType",
    }

    attribute_map: dict[str, str] = {
        "failure_details": "failureDetails",
        "failure_reason": "failureReason",
        "type": "type",
    }

    subtype_mapping: dict[str, str] = {
        "type": "GsaExportFailureType",
    }

    discriminator_value_class_map = {
        "record".lower(): "#/components/schemas/GsaRecordExportFailure",
        "link".lower(): "#/components/schemas/GsaLinkExportFailure",
        "attribute".lower(): "#/components/schemas/GsaAttributeExportFailure",
        "datum".lower(): "#/components/schemas/GsaDatumExportFailure",
        "rollup".lower(): "#/components/schemas/GsaRollupExportFailure",
    }

    discriminator: Optional[str] = "type"

    def __init__(
        self,
        *,
        failure_details: "str",
        failure_reason: "str",
        type: "GsaExportFailureType",
    ) -> None:
        """GsaExportFailure - a model defined in Swagger

        Parameters
        ----------
        failure_details: str
        failure_reason: str
        type: GsaExportFailureType
        """
        self._type: GsaExportFailureType
        self._failure_details: str
        self._failure_reason: str

        self.type = type
        self.failure_details = failure_details
        self.failure_reason = failure_reason

    @property
    def type(self) -> "GsaExportFailureType":
        """Gets the type of this GsaExportFailure.

        Returns
        -------
        GsaExportFailureType
            The type of this GsaExportFailure.
        """
        return self._type

    @type.setter
    def type(self, type: "GsaExportFailureType") -> None:
        """Sets the type of this GsaExportFailure.

        Parameters
        ----------
        type: GsaExportFailureType
            The type of this GsaExportFailure.
        """
        # Field is not nullable
        if type is None:
            raise ValueError("Invalid value for 'type', must not be 'None'")
        # Field is required
        if type is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'type', must not be 'Unset'")
        self._type = type

    @property
    def failure_details(self) -> "str":
        """Gets the failure_details of this GsaExportFailure.

        Returns
        -------
        str
            The failure_details of this GsaExportFailure.
        """
        return self._failure_details

    @failure_details.setter
    def failure_details(self, failure_details: "str") -> None:
        """Sets the failure_details of this GsaExportFailure.

        Parameters
        ----------
        failure_details: str
            The failure_details of this GsaExportFailure.
        """
        # Field is not nullable
        if failure_details is None:
            raise ValueError("Invalid value for 'failure_details', must not be 'None'")
        # Field is required
        if failure_details is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'failure_details', must not be 'Unset'")
        self._failure_details = failure_details

    @property
    def failure_reason(self) -> "str":
        """Gets the failure_reason of this GsaExportFailure.

        Returns
        -------
        str
            The failure_reason of this GsaExportFailure.
        """
        return self._failure_reason

    @failure_reason.setter
    def failure_reason(self, failure_reason: "str") -> None:
        """Sets the failure_reason of this GsaExportFailure.

        Parameters
        ----------
        failure_reason: str
            The failure_reason of this GsaExportFailure.
        """
        # Field is not nullable
        if failure_reason is None:
            raise ValueError("Invalid value for 'failure_reason', must not be 'None'")
        # Field is required
        if failure_reason is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'failure_reason', must not be 'Unset'")
        self._failure_reason = failure_reason

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Returns the real base class as determined by the discriminator

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class
        """
        discriminator_value = str(data[cls._get_discriminator_field_name()]).lower()
        # The actual class name is not available in swagger-codegen,
        # so we have to extract it from the JSON reference
        return cls.discriminator_value_class_map[discriminator_value].rsplit("/", 1)[-1]

    @classmethod
    def _get_discriminator_field_name(cls) -> str:
        assert cls.discriminator
        name_tokens = cls.discriminator.split("_")
        later_tokens = [element.capitalize() for element in name_tokens[1:]]
        return "".join([name_tokens[0], *later_tokens])

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaExportFailure):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
