# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_maths_functional_error_detail import (  # noqa: F401
    GsaMathsFunctionalErrorDetail,
)
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_maths_functional_error_reason import (
    GsaMathsFunctionalErrorReason,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail(GsaMathsFunctionalErrorDetail):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "message": "str",
        "reason": "GsaMathsFunctionalErrorReason",
        "missing_parameter_guids": "list[str]",
    }

    attribute_map: dict[str, str] = {
        "message": "message",
        "reason": "reason",
        "missing_parameter_guids": "missingParameterGuids",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        message: "str",
        reason: "GsaMathsFunctionalErrorReason" = GsaMathsFunctionalErrorReason.EXPRESSIONSHAVEUNKNOWNPARAMETERS,
        missing_parameter_guids: "Union[list[str], None, Unset_Type]" = Unset,
    ) -> None:
        """GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail - a model defined in Swagger

        Parameters
        ----------
        message: str
        reason: GsaMathsFunctionalErrorReason
        missing_parameter_guids: list[str], optional
        """
        super().__init__(message=message, reason=reason)
        self._missing_parameter_guids: Union[list[str], None, Unset_Type] = Unset

        if missing_parameter_guids is not Unset:
            self.missing_parameter_guids = missing_parameter_guids

    @property
    def missing_parameter_guids(self) -> "Union[list[str], None, Unset_Type]":
        """Gets the missing_parameter_guids of this GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail.

        Returns
        -------
        Union[list[str], None, Unset_Type]
            The missing_parameter_guids of this GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail.
        """
        return self._missing_parameter_guids

    @missing_parameter_guids.setter
    def missing_parameter_guids(
        self, missing_parameter_guids: "Union[list[str], None, Unset_Type]"
    ) -> None:
        """Sets the missing_parameter_guids of this GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail.

        Parameters
        ----------
        missing_parameter_guids: Union[list[str], None, Unset_Type]
            The missing_parameter_guids of this GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail.
        """
        self._missing_parameter_guids = missing_parameter_guids

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaExpressionsHaveUnknownParametersMathsFunctionalErrorDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
