# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_attribute_error_detail import (  # noqa: F401
    GsaAttributeErrorDetail,
)
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_attribute_error_reason import (
    GsaAttributeErrorReason,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaNoSuchEntityTabularColumnErrorDetail(GsaAttributeErrorDetail):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "message": "str",
        "reason": "GsaAttributeErrorReason",
        "database_key": "str",
        "entity_type": "GsaTabularColumnNoSuchEntityType",
        "guid": "str",
        "tabular_column_name": "str",
    }

    attribute_map: dict[str, str] = {
        "message": "message",
        "reason": "reason",
        "database_key": "databaseKey",
        "entity_type": "entityType",
        "guid": "guid",
        "tabular_column_name": "tabularColumnName",
    }

    subtype_mapping: dict[str, str] = {
        "entityType": "GsaTabularColumnNoSuchEntityType",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        message: "str",
        reason: "GsaAttributeErrorReason" = GsaAttributeErrorReason.TABULARCOLUMNNOSUCHENTITY,
        database_key: "Union[str, None, Unset_Type]" = Unset,
        entity_type: "Union[GsaTabularColumnNoSuchEntityType, Unset_Type]" = Unset,
        guid: "Union[str, Unset_Type]" = Unset,
        tabular_column_name: "Union[str, None, Unset_Type]" = Unset,
    ) -> None:
        """GsaNoSuchEntityTabularColumnErrorDetail - a model defined in Swagger

        Parameters
        ----------
        message: str
        reason: GsaAttributeErrorReason
        database_key: str, optional
        entity_type: GsaTabularColumnNoSuchEntityType, optional
        guid: str, optional
        tabular_column_name: str, optional
        """
        super().__init__(message=message, reason=reason)
        self._tabular_column_name: Union[str, None, Unset_Type] = Unset
        self._guid: Union[str, Unset_Type] = Unset
        self._database_key: Union[str, None, Unset_Type] = Unset
        self._entity_type: Union[GsaTabularColumnNoSuchEntityType, Unset_Type] = Unset

        if tabular_column_name is not Unset:
            self.tabular_column_name = tabular_column_name
        if guid is not Unset:
            self.guid = guid
        if database_key is not Unset:
            self.database_key = database_key
        if entity_type is not Unset:
            self.entity_type = entity_type

    @property
    def tabular_column_name(self) -> "Union[str, None, Unset_Type]":
        """Gets the tabular_column_name of this GsaNoSuchEntityTabularColumnErrorDetail.

        Returns
        -------
        Union[str, None, Unset_Type]
            The tabular_column_name of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        return self._tabular_column_name

    @tabular_column_name.setter
    def tabular_column_name(self, tabular_column_name: "Union[str, None, Unset_Type]") -> None:
        """Sets the tabular_column_name of this GsaNoSuchEntityTabularColumnErrorDetail.

        Parameters
        ----------
        tabular_column_name: Union[str, None, Unset_Type]
            The tabular_column_name of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        self._tabular_column_name = tabular_column_name

    @property
    def guid(self) -> "Union[str, Unset_Type]":
        """Gets the guid of this GsaNoSuchEntityTabularColumnErrorDetail.

        Returns
        -------
        Union[str, Unset_Type]
            The guid of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        return self._guid

    @guid.setter
    def guid(self, guid: "Union[str, Unset_Type]") -> None:
        """Sets the guid of this GsaNoSuchEntityTabularColumnErrorDetail.

        Parameters
        ----------
        guid: Union[str, Unset_Type]
            The guid of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        # Field is not nullable
        if guid is None:
            raise ValueError("Invalid value for 'guid', must not be 'None'")
        self._guid = guid

    @property
    def database_key(self) -> "Union[str, None, Unset_Type]":
        """Gets the database_key of this GsaNoSuchEntityTabularColumnErrorDetail.

        Returns
        -------
        Union[str, None, Unset_Type]
            The database_key of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        return self._database_key

    @database_key.setter
    def database_key(self, database_key: "Union[str, None, Unset_Type]") -> None:
        """Sets the database_key of this GsaNoSuchEntityTabularColumnErrorDetail.

        Parameters
        ----------
        database_key: Union[str, None, Unset_Type]
            The database_key of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        self._database_key = database_key

    @property
    def entity_type(self) -> "Union[GsaTabularColumnNoSuchEntityType, Unset_Type]":
        """Gets the entity_type of this GsaNoSuchEntityTabularColumnErrorDetail.

        Returns
        -------
        Union[GsaTabularColumnNoSuchEntityType, Unset_Type]
            The entity_type of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(
        self, entity_type: "Union[GsaTabularColumnNoSuchEntityType, Unset_Type]"
    ) -> None:
        """Sets the entity_type of this GsaNoSuchEntityTabularColumnErrorDetail.

        Parameters
        ----------
        entity_type: Union[GsaTabularColumnNoSuchEntityType, Unset_Type]
            The entity_type of this GsaNoSuchEntityTabularColumnErrorDetail.
        """
        # Field is not nullable
        if entity_type is None:
            raise ValueError("Invalid value for 'entity_type', must not be 'None'")
        self._entity_type = entity_type

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaNoSuchEntityTabularColumnErrorDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
