# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_parameter_content_error_detail import (  # noqa: F401
    GsaParameterContentErrorDetail,
)
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_parameter_content_error_reason import (
    GsaParameterContentErrorReason,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaNoSuchParameterValueParameterContentErrorDetail(GsaParameterContentErrorDetail):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "message": "str",
        "reason": "GsaParameterContentErrorReason",
        "database_key": "str",
        "parameter_guid": "str",
        "parameter_value_guid": "str",
    }

    attribute_map: dict[str, str] = {
        "message": "message",
        "reason": "reason",
        "database_key": "databaseKey",
        "parameter_guid": "parameterGuid",
        "parameter_value_guid": "parameterValueGuid",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        message: "str",
        reason: "GsaParameterContentErrorReason" = GsaParameterContentErrorReason.NOSUCHPARAMETERVALUE,
        database_key: "Union[str, None, Unset_Type]" = Unset,
        parameter_guid: "Union[str, Unset_Type]" = Unset,
        parameter_value_guid: "Union[str, Unset_Type]" = Unset,
    ) -> None:
        """GsaNoSuchParameterValueParameterContentErrorDetail - a model defined in Swagger

        Parameters
        ----------
        message: str
        reason: GsaParameterContentErrorReason
        database_key: str, optional
        parameter_guid: str, optional
        parameter_value_guid: str, optional
        """
        super().__init__(message=message, reason=reason)
        self._parameter_value_guid: Union[str, Unset_Type] = Unset
        self._parameter_guid: Union[str, Unset_Type] = Unset
        self._database_key: Union[str, None, Unset_Type] = Unset

        if parameter_value_guid is not Unset:
            self.parameter_value_guid = parameter_value_guid
        if parameter_guid is not Unset:
            self.parameter_guid = parameter_guid
        if database_key is not Unset:
            self.database_key = database_key

    @property
    def parameter_value_guid(self) -> "Union[str, Unset_Type]":
        """Gets the parameter_value_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.

        Returns
        -------
        Union[str, Unset_Type]
            The parameter_value_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.
        """
        return self._parameter_value_guid

    @parameter_value_guid.setter
    def parameter_value_guid(self, parameter_value_guid: "Union[str, Unset_Type]") -> None:
        """Sets the parameter_value_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.

        Parameters
        ----------
        parameter_value_guid: Union[str, Unset_Type]
            The parameter_value_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.
        """
        # Field is not nullable
        if parameter_value_guid is None:
            raise ValueError("Invalid value for 'parameter_value_guid', must not be 'None'")
        self._parameter_value_guid = parameter_value_guid

    @property
    def parameter_guid(self) -> "Union[str, Unset_Type]":
        """Gets the parameter_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.

        Returns
        -------
        Union[str, Unset_Type]
            The parameter_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.
        """
        return self._parameter_guid

    @parameter_guid.setter
    def parameter_guid(self, parameter_guid: "Union[str, Unset_Type]") -> None:
        """Sets the parameter_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.

        Parameters
        ----------
        parameter_guid: Union[str, Unset_Type]
            The parameter_guid of this GsaNoSuchParameterValueParameterContentErrorDetail.
        """
        # Field is not nullable
        if parameter_guid is None:
            raise ValueError("Invalid value for 'parameter_guid', must not be 'None'")
        self._parameter_guid = parameter_guid

    @property
    def database_key(self) -> "Union[str, None, Unset_Type]":
        """Gets the database_key of this GsaNoSuchParameterValueParameterContentErrorDetail.

        Returns
        -------
        Union[str, None, Unset_Type]
            The database_key of this GsaNoSuchParameterValueParameterContentErrorDetail.
        """
        return self._database_key

    @database_key.setter
    def database_key(self, database_key: "Union[str, None, Unset_Type]") -> None:
        """Sets the database_key of this GsaNoSuchParameterValueParameterContentErrorDetail.

        Parameters
        ----------
        database_key: Union[str, None, Unset_Type]
            The database_key of this GsaNoSuchParameterValueParameterContentErrorDetail.
        """
        self._database_key = database_key

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaNoSuchParameterValueParameterContentErrorDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
