# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_maths_functional_error_detail import (  # noqa: F401
    GsaMathsFunctionalErrorDetail,
)
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_maths_functional_error_reason import (
    GsaMathsFunctionalErrorReason,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaParameterContentUnknownParametersMathsFunctionalErrorDetail(GsaMathsFunctionalErrorDetail):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "message": "str",
        "reason": "GsaMathsFunctionalErrorReason",
        "attribute_guid": "str",
        "parameter_guids": "list[str]",
    }

    attribute_map: dict[str, str] = {
        "message": "message",
        "reason": "reason",
        "attribute_guid": "attributeGuid",
        "parameter_guids": "parameterGuids",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        message: "str",
        reason: "GsaMathsFunctionalErrorReason" = GsaMathsFunctionalErrorReason.PARAMETERCONTENTUNKNOWNPARAMETERS,
        attribute_guid: "Union[str, None, Unset_Type]" = Unset,
        parameter_guids: "Union[list[str], None, Unset_Type]" = Unset,
    ) -> None:
        """GsaParameterContentUnknownParametersMathsFunctionalErrorDetail - a model defined in Swagger

        Parameters
        ----------
        message: str
        reason: GsaMathsFunctionalErrorReason
        attribute_guid: str, optional
        parameter_guids: list[str], optional
        """
        super().__init__(message=message, reason=reason)
        self._parameter_guids: Union[list[str], None, Unset_Type] = Unset
        self._attribute_guid: Union[str, None, Unset_Type] = Unset

        if parameter_guids is not Unset:
            self.parameter_guids = parameter_guids
        if attribute_guid is not Unset:
            self.attribute_guid = attribute_guid

    @property
    def parameter_guids(self) -> "Union[list[str], None, Unset_Type]":
        """Gets the parameter_guids of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.

        Returns
        -------
        Union[list[str], None, Unset_Type]
            The parameter_guids of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.
        """
        return self._parameter_guids

    @parameter_guids.setter
    def parameter_guids(self, parameter_guids: "Union[list[str], None, Unset_Type]") -> None:
        """Sets the parameter_guids of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.

        Parameters
        ----------
        parameter_guids: Union[list[str], None, Unset_Type]
            The parameter_guids of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.
        """
        self._parameter_guids = parameter_guids

    @property
    def attribute_guid(self) -> "Union[str, None, Unset_Type]":
        """Gets the attribute_guid of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.

        Returns
        -------
        Union[str, None, Unset_Type]
            The attribute_guid of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.
        """
        return self._attribute_guid

    @attribute_guid.setter
    def attribute_guid(self, attribute_guid: "Union[str, None, Unset_Type]") -> None:
        """Sets the attribute_guid of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.

        Parameters
        ----------
        attribute_guid: Union[str, None, Unset_Type]
            The attribute_guid of this GsaParameterContentUnknownParametersMathsFunctionalErrorDetail.
        """
        self._attribute_guid = attribute_guid

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaParameterContentUnknownParametersMathsFunctionalErrorDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
