# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaPermission(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "guid": "str",
        "name": "str",
        "role": "str",
        "description": "str",
        "set_message": "str",
        "unset_message": "str",
    }

    attribute_map: dict[str, str] = {
        "guid": "guid",
        "name": "name",
        "role": "role",
        "description": "description",
        "set_message": "setMessage",
        "unset_message": "unsetMessage",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        guid: "str",
        name: "str",
        role: "str",
        description: "Union[str, None, Unset_Type]" = Unset,
        set_message: "Union[str, None, Unset_Type]" = Unset,
        unset_message: "Union[str, None, Unset_Type]" = Unset,
    ) -> None:
        """GsaPermission - a model defined in Swagger

        Parameters
        ----------
        guid: str
        name: str
        role: str
        description: str, optional
        set_message: str, optional
        unset_message: str, optional
        """
        self._role: str
        self._description: Union[str, None, Unset_Type] = Unset
        self._set_message: Union[str, None, Unset_Type] = Unset
        self._unset_message: Union[str, None, Unset_Type] = Unset
        self._name: str
        self._guid: str

        self.role = role
        if description is not Unset:
            self.description = description
        if set_message is not Unset:
            self.set_message = set_message
        if unset_message is not Unset:
            self.unset_message = unset_message
        self.name = name
        self.guid = guid

    @property
    def role(self) -> "str":
        """Gets the role of this GsaPermission.

        Returns
        -------
        str
            The role of this GsaPermission.
        """
        return self._role

    @role.setter
    def role(self, role: "str") -> None:
        """Sets the role of this GsaPermission.

        Parameters
        ----------
        role: str
            The role of this GsaPermission.
        """
        # Field is not nullable
        if role is None:
            raise ValueError("Invalid value for 'role', must not be 'None'")
        # Field is required
        if role is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'role', must not be 'Unset'")
        self._role = role

    @property
    def description(self) -> "Union[str, None, Unset_Type]":
        """Gets the description of this GsaPermission.

        Returns
        -------
        Union[str, None, Unset_Type]
            The description of this GsaPermission.
        """
        return self._description

    @description.setter
    def description(self, description: "Union[str, None, Unset_Type]") -> None:
        """Sets the description of this GsaPermission.

        Parameters
        ----------
        description: Union[str, None, Unset_Type]
            The description of this GsaPermission.
        """
        self._description = description

    @property
    def set_message(self) -> "Union[str, None, Unset_Type]":
        """Gets the set_message of this GsaPermission.
        Message to show when this permission is set.

        Returns
        -------
        Union[str, None, Unset_Type]
            The set_message of this GsaPermission.
        """
        return self._set_message

    @set_message.setter
    def set_message(self, set_message: "Union[str, None, Unset_Type]") -> None:
        """Sets the set_message of this GsaPermission.
        Message to show when this permission is set.

        Parameters
        ----------
        set_message: Union[str, None, Unset_Type]
            The set_message of this GsaPermission.
        """
        self._set_message = set_message

    @property
    def unset_message(self) -> "Union[str, None, Unset_Type]":
        """Gets the unset_message of this GsaPermission.
        Message to show when this permission is not set.

        Returns
        -------
        Union[str, None, Unset_Type]
            The unset_message of this GsaPermission.
        """
        return self._unset_message

    @unset_message.setter
    def unset_message(self, unset_message: "Union[str, None, Unset_Type]") -> None:
        """Sets the unset_message of this GsaPermission.
        Message to show when this permission is not set.

        Parameters
        ----------
        unset_message: Union[str, None, Unset_Type]
            The unset_message of this GsaPermission.
        """
        self._unset_message = unset_message

    @property
    def name(self) -> "str":
        """Gets the name of this GsaPermission.

        Returns
        -------
        str
            The name of this GsaPermission.
        """
        return self._name

    @name.setter
    def name(self, name: "str") -> None:
        """Sets the name of this GsaPermission.

        Parameters
        ----------
        name: str
            The name of this GsaPermission.
        """
        # Field is not nullable
        if name is None:
            raise ValueError("Invalid value for 'name', must not be 'None'")
        # Field is required
        if name is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'name', must not be 'Unset'")
        self._name = name

    @property
    def guid(self) -> "str":
        """Gets the guid of this GsaPermission.

        Returns
        -------
        str
            The guid of this GsaPermission.
        """
        return self._guid

    @guid.setter
    def guid(self, guid: "str") -> None:
        """Sets the guid of this GsaPermission.

        Parameters
        ----------
        guid: str
            The guid of this GsaPermission.
        """
        # Field is not nullable
        if guid is None:
            raise ValueError("Invalid value for 'guid', must not be 'None'")
        # Field is required
        if guid is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'guid', must not be 'Unset'")
        self._guid = guid

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaPermission):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
