# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_criterion import GsaCriterion  # noqa: F401
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_criterion_type import GsaCriterionType

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaRecordAncestorHistoryCriterion(GsaCriterion):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "direct_parent_only": "bool",
        "type": "GsaCriterionType",
        "ancestor_history_guid": "str",
    }

    attribute_map: dict[str, str] = {
        "direct_parent_only": "directParentOnly",
        "type": "type",
        "ancestor_history_guid": "ancestorHistoryGuid",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        direct_parent_only: "bool",
        type: "GsaCriterionType" = GsaCriterionType.RECORDANCESTORHISTORY,
        ancestor_history_guid: "Union[str, None, Unset_Type]" = Unset,
    ) -> None:
        """GsaRecordAncestorHistoryCriterion - a model defined in Swagger

        Parameters
        ----------
        direct_parent_only: bool
        type: GsaCriterionType
        ancestor_history_guid: str, optional
        """
        super().__init__(type=type)
        self._ancestor_history_guid: Union[str, None, Unset_Type] = Unset
        self._direct_parent_only: bool

        if ancestor_history_guid is not Unset:
            self.ancestor_history_guid = ancestor_history_guid
        self.direct_parent_only = direct_parent_only

    @property
    def ancestor_history_guid(self) -> "Union[str, None, Unset_Type]":
        """Gets the ancestor_history_guid of this GsaRecordAncestorHistoryCriterion.

        Returns
        -------
        Union[str, None, Unset_Type]
            The ancestor_history_guid of this GsaRecordAncestorHistoryCriterion.
        """
        return self._ancestor_history_guid

    @ancestor_history_guid.setter
    def ancestor_history_guid(self, ancestor_history_guid: "Union[str, None, Unset_Type]") -> None:
        """Sets the ancestor_history_guid of this GsaRecordAncestorHistoryCriterion.

        Parameters
        ----------
        ancestor_history_guid: Union[str, None, Unset_Type]
            The ancestor_history_guid of this GsaRecordAncestorHistoryCriterion.
        """
        self._ancestor_history_guid = ancestor_history_guid

    @property
    def direct_parent_only(self) -> "bool":
        """Gets the direct_parent_only of this GsaRecordAncestorHistoryCriterion.

        Returns
        -------
        bool
            The direct_parent_only of this GsaRecordAncestorHistoryCriterion.
        """
        return self._direct_parent_only

    @direct_parent_only.setter
    def direct_parent_only(self, direct_parent_only: "bool") -> None:
        """Sets the direct_parent_only of this GsaRecordAncestorHistoryCriterion.

        Parameters
        ----------
        direct_parent_only: bool
            The direct_parent_only of this GsaRecordAncestorHistoryCriterion.
        """
        # Field is not nullable
        if direct_parent_only is None:
            raise ValueError("Invalid value for 'direct_parent_only', must not be 'None'")
        # Field is required
        if direct_parent_only is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'direct_parent_only', must not be 'Unset'")
        self._direct_parent_only = direct_parent_only

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaRecordAncestorHistoryCriterion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
