# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaRecordCapabilities(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "can_delete": "bool",
        "can_get_modifiable_version": "bool",
        "can_modify": "bool",
        "can_release": "bool",
        "can_withdraw": "bool",
        "can_write": "bool",
    }

    attribute_map: dict[str, str] = {
        "can_delete": "canDelete",
        "can_get_modifiable_version": "canGetModifiableVersion",
        "can_modify": "canModify",
        "can_release": "canRelease",
        "can_withdraw": "canWithdraw",
        "can_write": "canWrite",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        can_delete: "bool",
        can_get_modifiable_version: "bool",
        can_modify: "bool",
        can_release: "bool",
        can_withdraw: "bool",
        can_write: "bool",
    ) -> None:
        """GsaRecordCapabilities - a model defined in Swagger

        Parameters
        ----------
        can_delete: bool
        can_get_modifiable_version: bool
        can_modify: bool
        can_release: bool
        can_withdraw: bool
        can_write: bool
        """
        self._can_write: bool
        self._can_modify: bool
        self._can_release: bool
        self._can_get_modifiable_version: bool
        self._can_withdraw: bool
        self._can_delete: bool

        self.can_write = can_write
        self.can_modify = can_modify
        self.can_release = can_release
        self.can_get_modifiable_version = can_get_modifiable_version
        self.can_withdraw = can_withdraw
        self.can_delete = can_delete

    @property
    def can_write(self) -> "bool":
        """Gets the can_write of this GsaRecordCapabilities.
        True if the current user has write permission for this record version, and is in write mode.  Write permission is required to edit record properties, and to perform version control actions.

        Returns
        -------
        bool
            The can_write of this GsaRecordCapabilities.
        """
        return self._can_write

    @can_write.setter
    def can_write(self, can_write: "bool") -> None:
        """Sets the can_write of this GsaRecordCapabilities.
        True if the current user has write permission for this record version, and is in write mode.  Write permission is required to edit record properties, and to perform version control actions.

        Parameters
        ----------
        can_write: bool
            The can_write of this GsaRecordCapabilities.
        """
        # Field is not nullable
        if can_write is None:
            raise ValueError("Invalid value for 'can_write', must not be 'None'")
        # Field is required
        if can_write is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'can_write', must not be 'Unset'")
        self._can_write = can_write

    @property
    def can_modify(self) -> "bool":
        """Gets the can_modify of this GsaRecordCapabilities.
        True if the current user can modify this record version, e.g. edit record properties.  The user needs write permission, and if the table is version controlled, the record must be unreleased.

        Returns
        -------
        bool
            The can_modify of this GsaRecordCapabilities.
        """
        return self._can_modify

    @can_modify.setter
    def can_modify(self, can_modify: "bool") -> None:
        """Sets the can_modify of this GsaRecordCapabilities.
        True if the current user can modify this record version, e.g. edit record properties.  The user needs write permission, and if the table is version controlled, the record must be unreleased.

        Parameters
        ----------
        can_modify: bool
            The can_modify of this GsaRecordCapabilities.
        """
        # Field is not nullable
        if can_modify is None:
            raise ValueError("Invalid value for 'can_modify', must not be 'None'")
        # Field is required
        if can_modify is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'can_modify', must not be 'Unset'")
        self._can_modify = can_modify

    @property
    def can_release(self) -> "bool":
        """Gets the can_release of this GsaRecordCapabilities.
        True if the current user can release this record version.

        Returns
        -------
        bool
            The can_release of this GsaRecordCapabilities.
        """
        return self._can_release

    @can_release.setter
    def can_release(self, can_release: "bool") -> None:
        """Sets the can_release of this GsaRecordCapabilities.
        True if the current user can release this record version.

        Parameters
        ----------
        can_release: bool
            The can_release of this GsaRecordCapabilities.
        """
        # Field is not nullable
        if can_release is None:
            raise ValueError("Invalid value for 'can_release', must not be 'None'")
        # Field is required
        if can_release is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'can_release', must not be 'Unset'")
        self._can_release = can_release

    @property
    def can_get_modifiable_version(self) -> "bool":
        """Gets the can_get_modifiable_version of this GsaRecordCapabilities.
        True if the current user can get a modifiable version of this record version (gets the latest modifiable record version, or creates a new one if none exists).

        Returns
        -------
        bool
            The can_get_modifiable_version of this GsaRecordCapabilities.
        """
        return self._can_get_modifiable_version

    @can_get_modifiable_version.setter
    def can_get_modifiable_version(self, can_get_modifiable_version: "bool") -> None:
        """Sets the can_get_modifiable_version of this GsaRecordCapabilities.
        True if the current user can get a modifiable version of this record version (gets the latest modifiable record version, or creates a new one if none exists).

        Parameters
        ----------
        can_get_modifiable_version: bool
            The can_get_modifiable_version of this GsaRecordCapabilities.
        """
        # Field is not nullable
        if can_get_modifiable_version is None:
            raise ValueError("Invalid value for 'can_get_modifiable_version', must not be 'None'")
        # Field is required
        if can_get_modifiable_version is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'can_get_modifiable_version', must not be 'Unset'")
        self._can_get_modifiable_version = can_get_modifiable_version

    @property
    def can_withdraw(self) -> "bool":
        """Gets the can_withdraw of this GsaRecordCapabilities.
        True if the current user can withdraw this record version.

        Returns
        -------
        bool
            The can_withdraw of this GsaRecordCapabilities.
        """
        return self._can_withdraw

    @can_withdraw.setter
    def can_withdraw(self, can_withdraw: "bool") -> None:
        """Sets the can_withdraw of this GsaRecordCapabilities.
        True if the current user can withdraw this record version.

        Parameters
        ----------
        can_withdraw: bool
            The can_withdraw of this GsaRecordCapabilities.
        """
        # Field is not nullable
        if can_withdraw is None:
            raise ValueError("Invalid value for 'can_withdraw', must not be 'None'")
        # Field is required
        if can_withdraw is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'can_withdraw', must not be 'Unset'")
        self._can_withdraw = can_withdraw

    @property
    def can_delete(self) -> "bool":
        """Gets the can_delete of this GsaRecordCapabilities.
        True if the current user can delete this record version.

        Returns
        -------
        bool
            The can_delete of this GsaRecordCapabilities.
        """
        return self._can_delete

    @can_delete.setter
    def can_delete(self, can_delete: "bool") -> None:
        """Sets the can_delete of this GsaRecordCapabilities.
        True if the current user can delete this record version.

        Parameters
        ----------
        can_delete: bool
            The can_delete of this GsaRecordCapabilities.
        """
        # Field is not nullable
        if can_delete is None:
            raise ValueError("Invalid value for 'can_delete', must not be 'None'")
        # Field is required
        if can_delete is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'can_delete', must not be 'Unset'")
        self._can_delete = can_delete

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaRecordCapabilities):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
