# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_criterion import GsaCriterion  # noqa: F401
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_criterion_type import GsaCriterionType

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaRecordPropertyCriterion(GsaCriterion):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "inner_criterion": "GsaDatumCriterion",
        "type": "GsaCriterionType",
        "_property": "GsaSearchableRecordProperty",
    }

    attribute_map: dict[str, str] = {
        "inner_criterion": "innerCriterion",
        "type": "type",
        "_property": "property",
    }

    subtype_mapping: dict[str, str] = {
        "property": "GsaSearchableRecordProperty",
        "innerCriterion": "GsaDatumCriterion",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        inner_criterion: "GsaDatumCriterion",
        type: "GsaCriterionType" = GsaCriterionType.RECORDPROPERTY,
        _property: "Union[GsaSearchableRecordProperty, Unset_Type]" = Unset,
    ) -> None:
        """GsaRecordPropertyCriterion - a model defined in Swagger

        Parameters
        ----------
        inner_criterion: GsaDatumCriterion
        type: GsaCriterionType
        _property: GsaSearchableRecordProperty, optional
        """
        super().__init__(type=type)
        self.__property: Union[GsaSearchableRecordProperty, Unset_Type] = Unset
        self._inner_criterion: GsaDatumCriterion

        if _property is not Unset:
            self._property = _property
        self.inner_criterion = inner_criterion

    @property
    def _property(self) -> "Union[GsaSearchableRecordProperty, Unset_Type]":
        """Gets the _property of this GsaRecordPropertyCriterion.

        Returns
        -------
        Union[GsaSearchableRecordProperty, Unset_Type]
            The _property of this GsaRecordPropertyCriterion.
        """
        return self.__property

    @_property.setter
    def _property(self, _property: "Union[GsaSearchableRecordProperty, Unset_Type]") -> None:
        """Sets the _property of this GsaRecordPropertyCriterion.

        Parameters
        ----------
        _property: Union[GsaSearchableRecordProperty, Unset_Type]
            The _property of this GsaRecordPropertyCriterion.
        """
        # Field is not nullable
        if _property is None:
            raise ValueError("Invalid value for '_property', must not be 'None'")
        self.__property = _property

    @property
    def inner_criterion(self) -> "GsaDatumCriterion":
        """Gets the inner_criterion of this GsaRecordPropertyCriterion.

        Returns
        -------
        GsaDatumCriterion
            The inner_criterion of this GsaRecordPropertyCriterion.
        """
        return self._inner_criterion

    @inner_criterion.setter
    def inner_criterion(self, inner_criterion: "GsaDatumCriterion") -> None:
        """Sets the inner_criterion of this GsaRecordPropertyCriterion.

        Parameters
        ----------
        inner_criterion: GsaDatumCriterion
            The inner_criterion of this GsaRecordPropertyCriterion.
        """
        # Field is not nullable
        if inner_criterion is None:
            raise ValueError("Invalid value for 'inner_criterion', must not be 'None'")
        # Field is required
        if inner_criterion is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'inner_criterion', must not be 'Unset'")
        self._inner_criterion = inner_criterion

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaRecordPropertyCriterion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
