# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaRecordWithData(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "database_key": "str",
        "record_version_guid": "str",
        "data": "list[GsaDataExportDatum]",
        "properties": "list[GsaProperty]",
        "record_history_guid": "str",
    }

    attribute_map: dict[str, str] = {
        "database_key": "databaseKey",
        "record_version_guid": "recordVersionGuid",
        "data": "data",
        "properties": "properties",
        "record_history_guid": "recordHistoryGuid",
    }

    subtype_mapping: dict[str, str] = {
        "data": "GsaDataExportDatum",
        "properties": "GsaProperty",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        database_key: "str",
        record_version_guid: "str",
        data: "Union[list[GsaDataExportDatum], None, Unset_Type]" = Unset,
        properties: "Union[list[GsaProperty], None, Unset_Type]" = Unset,
        record_history_guid: "Union[str, Unset_Type]" = Unset,
    ) -> None:
        """GsaRecordWithData - a model defined in Swagger

        Parameters
        ----------
        database_key: str
        record_version_guid: str
        data: list[GsaDataExportDatum], optional
        properties: list[GsaProperty], optional
        record_history_guid: str, optional
        """
        self._database_key: str
        self._record_history_guid: Union[str, Unset_Type] = Unset
        self._record_version_guid: str
        self._data: Union[list[GsaDataExportDatum], None, Unset_Type] = Unset
        self._properties: Union[list[GsaProperty], None, Unset_Type] = Unset

        self.database_key = database_key
        if record_history_guid is not Unset:
            self.record_history_guid = record_history_guid
        self.record_version_guid = record_version_guid
        if data is not Unset:
            self.data = data
        if properties is not Unset:
            self.properties = properties

    @property
    def database_key(self) -> "str":
        """Gets the database_key of this GsaRecordWithData.

        Returns
        -------
        str
            The database_key of this GsaRecordWithData.
        """
        return self._database_key

    @database_key.setter
    def database_key(self, database_key: "str") -> None:
        """Sets the database_key of this GsaRecordWithData.

        Parameters
        ----------
        database_key: str
            The database_key of this GsaRecordWithData.
        """
        # Field is not nullable
        if database_key is None:
            raise ValueError("Invalid value for 'database_key', must not be 'None'")
        # Field is required
        if database_key is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'database_key', must not be 'Unset'")
        self._database_key = database_key

    @property
    def record_history_guid(self) -> "Union[str, Unset_Type]":
        """Gets the record_history_guid of this GsaRecordWithData.

        Returns
        -------
        Union[str, Unset_Type]
            The record_history_guid of this GsaRecordWithData.
        """
        return self._record_history_guid

    @record_history_guid.setter
    def record_history_guid(self, record_history_guid: "Union[str, Unset_Type]") -> None:
        """Sets the record_history_guid of this GsaRecordWithData.

        Parameters
        ----------
        record_history_guid: Union[str, Unset_Type]
            The record_history_guid of this GsaRecordWithData.
        """
        # Field is not nullable
        if record_history_guid is None:
            raise ValueError("Invalid value for 'record_history_guid', must not be 'None'")
        self._record_history_guid = record_history_guid

    @property
    def record_version_guid(self) -> "str":
        """Gets the record_version_guid of this GsaRecordWithData.

        Returns
        -------
        str
            The record_version_guid of this GsaRecordWithData.
        """
        return self._record_version_guid

    @record_version_guid.setter
    def record_version_guid(self, record_version_guid: "str") -> None:
        """Sets the record_version_guid of this GsaRecordWithData.

        Parameters
        ----------
        record_version_guid: str
            The record_version_guid of this GsaRecordWithData.
        """
        # Field is not nullable
        if record_version_guid is None:
            raise ValueError("Invalid value for 'record_version_guid', must not be 'None'")
        # Field is required
        if record_version_guid is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'record_version_guid', must not be 'Unset'")
        self._record_version_guid = record_version_guid

    @property
    def data(self) -> "Union[list[GsaDataExportDatum], None, Unset_Type]":
        """Gets the data of this GsaRecordWithData.

        Returns
        -------
        Union[list[GsaDataExportDatum], None, Unset_Type]
            The data of this GsaRecordWithData.
        """
        return self._data

    @data.setter
    def data(self, data: "Union[list[GsaDataExportDatum], None, Unset_Type]") -> None:
        """Sets the data of this GsaRecordWithData.

        Parameters
        ----------
        data: Union[list[GsaDataExportDatum], None, Unset_Type]
            The data of this GsaRecordWithData.
        """
        self._data = data

    @property
    def properties(self) -> "Union[list[GsaProperty], None, Unset_Type]":
        """Gets the properties of this GsaRecordWithData.

        Returns
        -------
        Union[list[GsaProperty], None, Unset_Type]
            The properties of this GsaRecordWithData.
        """
        return self._properties

    @properties.setter
    def properties(self, properties: "Union[list[GsaProperty], None, Unset_Type]") -> None:
        """Sets the properties of this GsaRecordWithData.

        Parameters
        ----------
        properties: Union[list[GsaProperty], None, Unset_Type]
            The properties of this GsaRecordWithData.
        """
        self._properties = properties

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaRecordWithData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
