# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaTabularAttributeWithColumns(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "columns": "list[GsaSlimNamedEntity]",
        "tabular_attribute": "GsaSlimAttribute",
    }

    attribute_map: dict[str, str] = {
        "columns": "columns",
        "tabular_attribute": "tabularAttribute",
    }

    subtype_mapping: dict[str, str] = {
        "tabularAttribute": "GsaSlimAttribute",
        "columns": "GsaSlimNamedEntity",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        columns: "list[GsaSlimNamedEntity]",
        tabular_attribute: "GsaSlimAttribute",
    ) -> None:
        """GsaTabularAttributeWithColumns - a model defined in Swagger

        Parameters
        ----------
        columns: list[GsaSlimNamedEntity]
        tabular_attribute: GsaSlimAttribute
        """
        self._tabular_attribute: GsaSlimAttribute
        self._columns: list[GsaSlimNamedEntity]

        self.tabular_attribute = tabular_attribute
        self.columns = columns

    @property
    def tabular_attribute(self) -> "GsaSlimAttribute":
        """Gets the tabular_attribute of this GsaTabularAttributeWithColumns.

        Returns
        -------
        GsaSlimAttribute
            The tabular_attribute of this GsaTabularAttributeWithColumns.
        """
        return self._tabular_attribute

    @tabular_attribute.setter
    def tabular_attribute(self, tabular_attribute: "GsaSlimAttribute") -> None:
        """Sets the tabular_attribute of this GsaTabularAttributeWithColumns.

        Parameters
        ----------
        tabular_attribute: GsaSlimAttribute
            The tabular_attribute of this GsaTabularAttributeWithColumns.
        """
        # Field is not nullable
        if tabular_attribute is None:
            raise ValueError("Invalid value for 'tabular_attribute', must not be 'None'")
        # Field is required
        if tabular_attribute is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'tabular_attribute', must not be 'Unset'")
        self._tabular_attribute = tabular_attribute

    @property
    def columns(self) -> "list[GsaSlimNamedEntity]":
        """Gets the columns of this GsaTabularAttributeWithColumns.

        Returns
        -------
        list[GsaSlimNamedEntity]
            The columns of this GsaTabularAttributeWithColumns.
        """
        return self._columns

    @columns.setter
    def columns(self, columns: "list[GsaSlimNamedEntity]") -> None:
        """Sets the columns of this GsaTabularAttributeWithColumns.

        Parameters
        ----------
        columns: list[GsaSlimNamedEntity]
            The columns of this GsaTabularAttributeWithColumns.
        """
        # Field is not nullable
        if columns is None:
            raise ValueError("Invalid value for 'columns', must not be 'None'")
        # Field is required
        if columns is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'columns', must not be 'Unset'")
        self._columns = columns

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaTabularAttributeWithColumns):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
