# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_attribute_error_detail import (  # noqa: F401
    GsaAttributeErrorDetail,
)
from ansys.grantami.serverapi_openapi.v2025r2.models.gsa_attribute_error_reason import (
    GsaAttributeErrorReason,
)

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaThresholdTypeAttributeErrorDetail(GsaAttributeErrorDetail):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "message": "str",
        "reason": "GsaAttributeErrorReason",
        "allowed_threshold_types": "list[GsaAttributeThresholdType]",
        "attribute_type": "GsaAttributeType",
        "threshold_type": "GsaAttributeThresholdType",
    }

    attribute_map: dict[str, str] = {
        "message": "message",
        "reason": "reason",
        "allowed_threshold_types": "allowedThresholdTypes",
        "attribute_type": "attributeType",
        "threshold_type": "thresholdType",
    }

    subtype_mapping: dict[str, str] = {
        "thresholdType": "GsaAttributeThresholdType",
        "attributeType": "GsaAttributeType",
        "allowedThresholdTypes": "GsaAttributeThresholdType",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        message: "str",
        reason: "GsaAttributeErrorReason" = GsaAttributeErrorReason.THRESHOLDTYPE,
        allowed_threshold_types: "Union[list[GsaAttributeThresholdType], None, Unset_Type]" = Unset,
        attribute_type: "Union[GsaAttributeType, Unset_Type]" = Unset,
        threshold_type: "Union[GsaAttributeThresholdType, Unset_Type]" = Unset,
    ) -> None:
        """GsaThresholdTypeAttributeErrorDetail - a model defined in Swagger

        Parameters
        ----------
        message: str
        reason: GsaAttributeErrorReason
        allowed_threshold_types: list[GsaAttributeThresholdType], optional
        attribute_type: GsaAttributeType, optional
        threshold_type: GsaAttributeThresholdType, optional
        """
        super().__init__(message=message, reason=reason)
        self._threshold_type: Union[GsaAttributeThresholdType, Unset_Type] = Unset
        self._attribute_type: Union[GsaAttributeType, Unset_Type] = Unset
        self._allowed_threshold_types: Union[list[GsaAttributeThresholdType], None, Unset_Type] = (
            Unset
        )

        if threshold_type is not Unset:
            self.threshold_type = threshold_type
        if attribute_type is not Unset:
            self.attribute_type = attribute_type
        if allowed_threshold_types is not Unset:
            self.allowed_threshold_types = allowed_threshold_types

    @property
    def threshold_type(self) -> "Union[GsaAttributeThresholdType, Unset_Type]":
        """Gets the threshold_type of this GsaThresholdTypeAttributeErrorDetail.

        Returns
        -------
        Union[GsaAttributeThresholdType, Unset_Type]
            The threshold_type of this GsaThresholdTypeAttributeErrorDetail.
        """
        return self._threshold_type

    @threshold_type.setter
    def threshold_type(
        self, threshold_type: "Union[GsaAttributeThresholdType, Unset_Type]"
    ) -> None:
        """Sets the threshold_type of this GsaThresholdTypeAttributeErrorDetail.

        Parameters
        ----------
        threshold_type: Union[GsaAttributeThresholdType, Unset_Type]
            The threshold_type of this GsaThresholdTypeAttributeErrorDetail.
        """
        # Field is not nullable
        if threshold_type is None:
            raise ValueError("Invalid value for 'threshold_type', must not be 'None'")
        self._threshold_type = threshold_type

    @property
    def attribute_type(self) -> "Union[GsaAttributeType, Unset_Type]":
        """Gets the attribute_type of this GsaThresholdTypeAttributeErrorDetail.

        Returns
        -------
        Union[GsaAttributeType, Unset_Type]
            The attribute_type of this GsaThresholdTypeAttributeErrorDetail.
        """
        return self._attribute_type

    @attribute_type.setter
    def attribute_type(self, attribute_type: "Union[GsaAttributeType, Unset_Type]") -> None:
        """Sets the attribute_type of this GsaThresholdTypeAttributeErrorDetail.

        Parameters
        ----------
        attribute_type: Union[GsaAttributeType, Unset_Type]
            The attribute_type of this GsaThresholdTypeAttributeErrorDetail.
        """
        # Field is not nullable
        if attribute_type is None:
            raise ValueError("Invalid value for 'attribute_type', must not be 'None'")
        self._attribute_type = attribute_type

    @property
    def allowed_threshold_types(self) -> "Union[list[GsaAttributeThresholdType], None, Unset_Type]":
        """Gets the allowed_threshold_types of this GsaThresholdTypeAttributeErrorDetail.

        Returns
        -------
        Union[list[GsaAttributeThresholdType], None, Unset_Type]
            The allowed_threshold_types of this GsaThresholdTypeAttributeErrorDetail.
        """
        return self._allowed_threshold_types

    @allowed_threshold_types.setter
    def allowed_threshold_types(
        self, allowed_threshold_types: "Union[list[GsaAttributeThresholdType], None, Unset_Type]"
    ) -> None:
        """Sets the allowed_threshold_types of this GsaThresholdTypeAttributeErrorDetail.

        Parameters
        ----------
        allowed_threshold_types: Union[list[GsaAttributeThresholdType], None, Unset_Type]
            The allowed_threshold_types of this GsaThresholdTypeAttributeErrorDetail.
        """
        self._allowed_threshold_types = allowed_threshold_types

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaThresholdTypeAttributeErrorDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
