# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaUnitConversionSet(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "factor": "float",
        "offset": "float",
        "source_unit_symbol": "str",
        "target_unit_symbol": "str",
    }

    attribute_map: dict[str, str] = {
        "factor": "factor",
        "offset": "offset",
        "source_unit_symbol": "sourceUnitSymbol",
        "target_unit_symbol": "targetUnitSymbol",
    }

    subtype_mapping: dict[str, str] = {}

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        factor: "float",
        offset: "float",
        source_unit_symbol: "str",
        target_unit_symbol: "str",
    ) -> None:
        """GsaUnitConversionSet - a model defined in Swagger

        Parameters
        ----------
        factor: float
        offset: float
        source_unit_symbol: str
        target_unit_symbol: str
        """
        self._source_unit_symbol: str
        self._target_unit_symbol: str
        self._factor: float
        self._offset: float

        self.source_unit_symbol = source_unit_symbol
        self.target_unit_symbol = target_unit_symbol
        self.factor = factor
        self.offset = offset

    @property
    def source_unit_symbol(self) -> "str":
        """Gets the source_unit_symbol of this GsaUnitConversionSet.

        Returns
        -------
        str
            The source_unit_symbol of this GsaUnitConversionSet.
        """
        return self._source_unit_symbol

    @source_unit_symbol.setter
    def source_unit_symbol(self, source_unit_symbol: "str") -> None:
        """Sets the source_unit_symbol of this GsaUnitConversionSet.

        Parameters
        ----------
        source_unit_symbol: str
            The source_unit_symbol of this GsaUnitConversionSet.
        """
        # Field is not nullable
        if source_unit_symbol is None:
            raise ValueError("Invalid value for 'source_unit_symbol', must not be 'None'")
        # Field is required
        if source_unit_symbol is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'source_unit_symbol', must not be 'Unset'")
        self._source_unit_symbol = source_unit_symbol

    @property
    def target_unit_symbol(self) -> "str":
        """Gets the target_unit_symbol of this GsaUnitConversionSet.

        Returns
        -------
        str
            The target_unit_symbol of this GsaUnitConversionSet.
        """
        return self._target_unit_symbol

    @target_unit_symbol.setter
    def target_unit_symbol(self, target_unit_symbol: "str") -> None:
        """Sets the target_unit_symbol of this GsaUnitConversionSet.

        Parameters
        ----------
        target_unit_symbol: str
            The target_unit_symbol of this GsaUnitConversionSet.
        """
        # Field is not nullable
        if target_unit_symbol is None:
            raise ValueError("Invalid value for 'target_unit_symbol', must not be 'None'")
        # Field is required
        if target_unit_symbol is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'target_unit_symbol', must not be 'Unset'")
        self._target_unit_symbol = target_unit_symbol

    @property
    def factor(self) -> "float":
        """Gets the factor of this GsaUnitConversionSet.

        Returns
        -------
        float
            The factor of this GsaUnitConversionSet.
        """
        return self._factor

    @factor.setter
    def factor(self, factor: "float") -> None:
        """Sets the factor of this GsaUnitConversionSet.

        Parameters
        ----------
        factor: float
            The factor of this GsaUnitConversionSet.
        """
        # Field is not nullable
        if factor is None:
            raise ValueError("Invalid value for 'factor', must not be 'None'")
        # Field is required
        if factor is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'factor', must not be 'Unset'")
        self._factor = factor

    @property
    def offset(self) -> "float":
        """Gets the offset of this GsaUnitConversionSet.

        Returns
        -------
        float
            The offset of this GsaUnitConversionSet.
        """
        return self._offset

    @offset.setter
    def offset(self, offset: "float") -> None:
        """Sets the offset of this GsaUnitConversionSet.

        Parameters
        ----------
        offset: float
            The offset of this GsaUnitConversionSet.
        """
        # Field is not nullable
        if offset is None:
            raise ValueError("Invalid value for 'offset', must not be 'None'")
        # Field is required
        if offset is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'offset', must not be 'Unset'")
        self._offset = offset

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaUnitConversionSet):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
