# Copyright (C) 2023 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
MI Server API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GsaUpdateUserPermission(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "flags": "GsaUpdateRecordListPermissionFlags",
        "user_or_group_identifier": "str",
    }

    attribute_map: dict[str, str] = {
        "flags": "flags",
        "user_or_group_identifier": "userOrGroupIdentifier",
    }

    subtype_mapping: dict[str, str] = {
        "flags": "GsaUpdateRecordListPermissionFlags",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        flags: "GsaUpdateRecordListPermissionFlags",
        user_or_group_identifier: "str",
    ) -> None:
        """GsaUpdateUserPermission - a model defined in Swagger

        Parameters
        ----------
        flags: GsaUpdateRecordListPermissionFlags
        user_or_group_identifier: str
        """
        self._user_or_group_identifier: str
        self._flags: GsaUpdateRecordListPermissionFlags

        self.user_or_group_identifier = user_or_group_identifier
        self.flags = flags

    @property
    def user_or_group_identifier(self) -> "str":
        """Gets the user_or_group_identifier of this GsaUpdateUserPermission.
        The user or group identifier

        Returns
        -------
        str
            The user_or_group_identifier of this GsaUpdateUserPermission.
        """
        return self._user_or_group_identifier

    @user_or_group_identifier.setter
    def user_or_group_identifier(self, user_or_group_identifier: "str") -> None:
        """Sets the user_or_group_identifier of this GsaUpdateUserPermission.
        The user or group identifier

        Parameters
        ----------
        user_or_group_identifier: str
            The user_or_group_identifier of this GsaUpdateUserPermission.
        """
        # Field is not nullable
        if user_or_group_identifier is None:
            raise ValueError("Invalid value for 'user_or_group_identifier', must not be 'None'")
        # Field is required
        if user_or_group_identifier is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'user_or_group_identifier', must not be 'Unset'")
        self._user_or_group_identifier = user_or_group_identifier

    @property
    def flags(self) -> "GsaUpdateRecordListPermissionFlags":
        """Gets the flags of this GsaUpdateUserPermission.

        Returns
        -------
        GsaUpdateRecordListPermissionFlags
            The flags of this GsaUpdateUserPermission.
        """
        return self._flags

    @flags.setter
    def flags(self, flags: "GsaUpdateRecordListPermissionFlags") -> None:
        """Sets the flags of this GsaUpdateUserPermission.

        Parameters
        ----------
        flags: GsaUpdateRecordListPermissionFlags
            The flags of this GsaUpdateUserPermission.
        """
        # Field is not nullable
        if flags is None:
            raise ValueError("Invalid value for 'flags', must not be 'None'")
        # Field is required
        if flags is Unset:  # type: ignore[comparison-overlap, unused-ignore]
            raise ValueError("Invalid value for 'flags', must not be 'Unset'")
        self._flags = flags

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GsaUpdateUserPermission):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
